diff -pruN 0.18-1/autogen.sh 0.18+20200417-1/autogen.sh
--- 0.18-1/autogen.sh	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/autogen.sh	2020-04-17 09:11:03.000000000 +0000
@@ -96,7 +96,7 @@ else
   AM_NEEDED=`fgrep AUTOMAKE_OPTIONS Makefile.am | $VERSIONGREP`
   AM_MAJOR_REQ=`echo $AM_NEEDED |cut -d. -f1`
   AM_MINOR_REQ=`echo $AM_NEEDED |cut -d. -f2`
-  
+
   echo "checking for automake $AM_NEEDED or later..."
 
   if [ $AM_MAJ -lt $AM_MAJOR_REQ -o $AM_MIN -lt $AM_MINOR_REQ ] ; then
diff -pruN 0.18-1/CHANGES 0.18+20200417-1/CHANGES
--- 0.18-1/CHANGES	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/CHANGES	2020-04-17 09:11:03.000000000 +0000
@@ -79,7 +79,7 @@ Version 0.7 (2004 December 8)
  * successfully decodes ubc test streams 042_21, 042_22 and 042_23
  * generic region template 3 handling with arbitrary AT locations
  * successfully decodes ubc test streams 042_6 and 042_7
- 
+
 Version 0.6 (2003 December 31)
 
  * minor portability fix for cygwin
@@ -94,7 +94,7 @@ Version 0.5 (2003 December 4)
 
 Version 0.4 (released 2003 August 1)
 
- * redid license header to simplify relabelling for commercial 
+ * redid license header to simplify relabelling for commercial
    distribution, borrowing from Ghostscript.
 
 Version 0.3 (released 2003 May 20)
diff -pruN 0.18-1/configure.ac.in 0.18+20200417-1/configure.ac.in
--- 0.18-1/configure.ac.in	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/configure.ac.in	2020-04-17 09:11:03.000000000 +0000
@@ -27,12 +27,12 @@ AC_PROG_LIBTOOL
 
 # platform specific compiler flags
 if test "x$GCC" = xyes; then
-  CFLAGS="$CFLAGS -Wall"
+  CFLAGS="$CFLAGS -Wall -Wsign-compare"
 fi
 
 # Checks for libraries.
 dnl by default we want png support if possible
-AC_ARG_WITH([libpng], 
+AC_ARG_WITH([libpng],
   AC_HELP_STRING([--with-libpng[=prefix]],
     [include support for png output (if libpng is available)]),
   [ac_cv_want_libpng="$withval"], [ac_cv_want_libpng="yes"])
@@ -68,9 +68,9 @@ AC_HEADER_STDC
 AC_CHECK_HEADERS([libintl.h stddef.h unistd.h strings.h])
 
 dnl We assume the fixed-size types from stdint.h. If that header is
-dnl not available, look for the same types in a few other headers. 
+dnl not available, look for the same types in a few other headers.
 dnl We also attempt to define them ourselves, but only use those if
-dnl the native versions aren't available. The substitutions happen 
+dnl the native versions aren't available. The substitutions happen
 dnl in a file config_types.h, whose template is created by autogen.sh
 
 stdint_types_in="no_replacement_found"
@@ -113,7 +113,7 @@ if test "x$ac_cv_header_stdint_h" != "xy
   elif test "x$stdint_types_discovered" = "xno"; then
     AC_MSG_ERROR([
 Unable to find suitable definitions of the stdint.h types (uint32_t and friends)
-You will have to define these yourself in a separate header. 
+You will have to define these yourself in a separate header.
 See config_win32.h for an example.
     ])
   fi
@@ -132,12 +132,11 @@ AC_C_BIGENDIAN
 AC_FUNC_MEMCMP
 dnl we use realloc() but don't depend on the zero-length behavior
 dnl tested by AC_FUNC_REALLOC
-AC_REPLACE_FUNCS([snprintf])
 
 AC_CHECK_FUNCS([memset strdup])
 
 dnl use our included getopt if the system doesn't have getopt_long()
-AC_CHECK_FUNC(getopt_long, 
+AC_CHECK_FUNC(getopt_long,
 	AC_DEFINE(HAVE_GETOPT_LONG,,
 	  [Define if the local libc includes getopt_long()]
 	),[
diff -pruN 0.18-1/config_win32.h 0.18+20200417-1/config_win32.h
--- 0.18-1/config_win32.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/config_win32.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/debian/changelog 0.18+20200417-1/debian/changelog
--- 0.18-1/debian/changelog	2020-03-15 09:48:03.000000000 +0000
+++ 0.18+20200417-1/debian/changelog	2020-04-23 08:01:35.000000000 +0000
@@ -1,3 +1,52 @@
+jbig2dec (0.18+20200417-1) unstable; urgency=medium
+
+  [ upstream ]
+  * development snapshot
+    + Separate command line tool error callback state from parameters.
+    + Mention all long options in usage and manpage.
+    + Add command line option to limit memory usage.
+    + Add more references to specification.
+    + Keep type of index and array length the same.
+    + Use unsigned suffix when defining UINT32_MAX.
+    + Handle under-/overflow detection and messaging better.
+    + Let arithmetic decoder and the underlying stream report errors.
+    + Add overflow detection for IAID context size.
+    + Treat end of stream as fatal error, and remember errors.
+    + Avoid artificially limiting jbig2dec.
+    + Avoid passing NULL buffer to snprintf().
+    + Remove trailing whitespace.
+    + Address all signedness comparison issues.
+    + Enable warnings for signedness in comparisons.
+    + Avoid warning by copying bytes instead of characters.
+    + Fix under/overflow handling in arithmetic integer decoder.
+    + Pass segment numbers as unsigned values to error callback.
+    + Avoid formatting error messages twice in error callback.
+    + Use size_t for string length.
+    + Handle errors from reading jbig2 streams.
+    + Always use uint32_t when counting pages.
+    + Use uint32_t when counting segments.
+    + Fix signedness conversions.
+    + Fix two overlooked warnings.
+    + Use correct define for maximum value of type.
+    + Record stream errors in separate struct field.
+    + Cast literal to avoid shifting outside of valid range.
+    + Need to store local copy of error message.
+    + Plug leak of image upon error.
+    + Adjust number of bytes consumed by MMR decoder.
+    + Initiate variable before avoids using uninited data
+      during cleanup.
+    + Refill input buffer upon failure to parse segment header.
+
+  [ Jonas Smedegaard ]
+  * copyright: update coverage
+  * use debhelper compatibility level 10 (not 9);
+    stop build-depend explicitly on dh-autoreconf libtool
+  * avoid running python test apparently relying on missing data files;
+    drop patch 1001; stop build-depend on python;
+    closes: bug#943139, thanks to Sandro Tosi
+
+ -- Jonas Smedegaard <dr@jones.dk>  Thu, 23 Apr 2020 10:01:35 +0200
+
 jbig2dec (0.18-1) unstable; urgency=medium
 
   [ upstream ]
diff -pruN 0.18-1/debian/compat 0.18+20200417-1/debian/compat
--- 0.18-1/debian/compat	2019-09-16 14:51:10.000000000 +0000
+++ 0.18+20200417-1/debian/compat	2020-04-23 07:35:58.000000000 +0000
@@ -1 +1 @@
-9
+10
diff -pruN 0.18-1/debian/control 0.18+20200417-1/debian/control
--- 0.18-1/debian/control	2020-03-15 09:44:54.000000000 +0000
+++ 0.18+20200417-1/debian/control	2020-04-23 08:01:35.000000000 +0000
@@ -8,10 +8,7 @@ Build-Depends:
  cdbs,
  d-shlibs,
  debhelper,
- dh-autoreconf,
  libpng-dev,
- libtool,
- python:native <!nocheck>,
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/printing-team/jbig2dec.git
 Vcs-Browser: https://salsa.debian.org/printing-team/jbig2dec
diff -pruN 0.18-1/debian/copyright 0.18+20200417-1/debian/copyright
--- 0.18-1/debian/copyright	2019-10-02 09:31:16.000000000 +0000
+++ 0.18+20200417-1/debian/copyright	2020-04-23 07:35:16.000000000 +0000
@@ -6,7 +6,7 @@ Source: http://git.ghostscript.com/?p=jb
 
 Files: *
 Copyright:
-  2001-2019, Artifex Software, Inc.
+  2001-2020, Artifex Software, Inc.
 License-Grant:
  jbig2dec is free software; you can redistribute it and/or modify it
  under the terms the GNU Affero General Public License as published by
@@ -41,7 +41,7 @@ License: pubic-domain
 
 Files: debian/*
 Copyright:
-  2010-2013,2015-2018, Jonas Smedegaard <dr@jones.dk>
+  2010-2013,2015-2020, Jonas Smedegaard <dr@jones.dk>
 License-Grant:
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
diff -pruN 0.18-1/debian/copyright_hints 0.18+20200417-1/debian/copyright_hints
--- 0.18-1/debian/copyright_hints	2020-03-15 09:47:39.000000000 +0000
+++ 0.18+20200417-1/debian/copyright_hints	2020-04-23 08:01:35.000000000 +0000
@@ -41,11 +41,10 @@ Files: config_win32.h
  jbig2_text.h
  jbig2dec.c
  memcmp.c
- memento.c
  memento.h
  os_types.h
  pbm2png.c
-Copyright: 2001-2019, Artifex Software, Inc.
+Copyright: 2001-2020, Artifex Software, Inc.
   2009-2018, Artifex Software, Inc.
 License: UNKNOWN
  FIXME
@@ -56,6 +55,7 @@ Files: CHANGES
  README
  autogen.sh
  configure.ac.in
+ debian/NEWS
  debian/compat
  debian/control
  debian/gbp.conf
@@ -79,16 +79,6 @@ Copyright: NONE
 License: UNKNOWN
  FIXME
 
-Files: debian/NEWS
-Copyright: NONE
-License: AGPL
- FIXME
-
-Files: LICENSE
-Copyright: headers.
-License: AGPL and/or Aladdin
- FIXME
-
 Files: COPYING
 Copyright: -like laws that apply to other kinds of
   2007, Free Software Foundation, Inc. <http:fsf.org/>
@@ -104,11 +94,6 @@ Copyright: -like laws that apply to othe
 License: AGPL-3
  FIXME
 
-Files: snprintf.c
-Copyright: 1997, Theo de Raadt
-License: BSD-2-clause
- FIXME
-
 Files: debian/copyright-check
 Copyright: 2016-2019, Jonas Smedegaard <dr@jones.dk>
   check
@@ -130,6 +115,12 @@ Copyright: 1989-1994, 1996-1999, 2001, F
 License: LGPL-2.1+
  FIXME
 
+Files: memento.c
+Copyright: 2009-2018, Artifex Software, Inc.
+  doNestedDisplay(c, depth+1);
+License: UNKNOWN
+ FIXME
+
 Files: debian/source/lintian-overrides
 Copyright: GPL-3+
   LGPL-2.1+
@@ -138,6 +129,11 @@ Copyright: GPL-3+
 License: UNKNOWN
  FIXME
 
+Files: LICENSE
+Copyright: headers.
+License: UNKNOWN
+ FIXME
+
 Files: sha1.h
 Copyright: NONE
 License: public-domain
diff -pruN 0.18-1/debian/patches/1001_ignore_python_test.patch 0.18+20200417-1/debian/patches/1001_ignore_python_test.patch
--- 0.18-1/debian/patches/1001_ignore_python_test.patch	2019-09-19 10:37:54.000000000 +0000
+++ 0.18+20200417-1/debian/patches/1001_ignore_python_test.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-Description: Always succeed python test
- Apparently the test rely on external missing data files
-Author: Jonas Smedegaard <dr@jones.dk>
-Forwarded: no
-Last-Update: 2010-04-21
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- a/test_jbig2dec.py
-+++ b/test_jbig2dec.py
-@@ -182,4 +182,4 @@
- # run the defined tests if we're called as a script
- if __name__ == "__main__":
-     result = suite.run()
--    sys.exit(not result)
-+    sys.exit(0)
diff -pruN 0.18-1/debian/patches/series 0.18+20200417-1/debian/patches/series
--- 0.18-1/debian/patches/series	2019-09-19 10:38:28.000000000 +0000
+++ 0.18+20200417-1/debian/patches/series	2020-04-23 08:01:35.000000000 +0000
@@ -1,4 +1,3 @@
-1001_ignore_python_test.patch
 1004_extract_infile_from_autogen-sh.patch
 2001_disable_memento.patch
 2002_abi_compat.patch
diff -pruN 0.18-1/debian/rules 0.18+20200417-1/debian/rules
--- 0.18-1/debian/rules	2019-09-19 10:31:24.000000000 +0000
+++ 0.18+20200417-1/debian/rules	2020-04-23 08:01:35.000000000 +0000
@@ -15,7 +15,8 @@ DEB_DH_AUTORECONF_ARGS += ./autogen.sh
 # Multiarch quirk (see also other uses of that variable in this file)
 DEB_CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 
-DEB_MAKE_CHECK_TARGET = check
+# avoid test_jbig2dec.py apparently relying on missing data files
+DEB_MAKE_CHECK_TARGET = check TESTS="test_sha1 test_huffman test_arith"
 
 DEB_INSTALL_MANPAGES_jbig2dec = debian/tmp/usr/share/man/man1/*
 
diff -pruN 0.18-1/jbig2_arith.c 0.18+20200417-1/jbig2_arith.c
--- 0.18-1/jbig2_arith.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -31,15 +31,16 @@
 
 struct _Jbig2ArithState {
     uint32_t C;
-    int A;
+    uint32_t A;
 
     int CT;
 
     uint32_t next_word;
-    int next_word_bytes;
+    size_t next_word_bytes;
+    int err;
 
     Jbig2WordStream *ws;
-    int offset;
+    size_t offset;
 };
 
 /*
@@ -53,13 +54,22 @@ struct _Jbig2ArithState {
   invitation to bitrot.
 */
 
-static void
-jbig2_arith_bytein(Jbig2ArithState *as)
+static int
+jbig2_arith_bytein(Jbig2Ctx *ctx, Jbig2ArithState *as)
 {
-    int new_bytes;
     byte B;
 
-    /* invariant: as->next_word_bytes > 0 */
+    /* Treat both errors and reading beyond end of stream as an error. */
+    if (as->err != 0) {
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read from underlying stream during arithmetic decoding");
+        return -1;
+    }
+    if (as->next_word_bytes == 0) {
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read beyond end of underlying stream during arithmetic decoding");
+        return -1;
+    }
+
+    /* At this point there is at least one byte in as->next_word. */
 
     /* This code confused me no end when I first read it, so a quick note
      * to save others (and future me's) from being similarly confused.
@@ -78,17 +88,30 @@ jbig2_arith_bytein(Jbig2ArithState *as)
      * that fact for the next byte we read.
      */
 
-    /* Figure G.3 */
+    /* Figure F.3 */
     B = (byte)((as->next_word >> 24) & 0xFF);
     if (B == 0xFF) {
         byte B1;
 
-        if (as->next_word_bytes == 1) {
-            Jbig2WordStream *ws = as->ws;
+        /* next_word_bytes can only be == 1 here, but let's be defensive. */
+        if (as->next_word_bytes <= 1) {
+            int ret = as->ws->get_next_word(ctx, as->ws, as->offset, &as->next_word);
+            if (ret < 0) {
+                as->err = 1;
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to check for marker code due to failure in underlying stream during arithmetic decoding");
+            }
+            as->next_word_bytes = (size_t) ret;
 
-            new_bytes = ws->get_next_word(ws, as->offset, &as->next_word);
-            as->next_word_bytes = new_bytes;
-            as->offset += new_bytes;
+            if (as->next_word_bytes == 0) {
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read end of possible terminating marker code, assuming terminating marker code");
+                as->next_word = 0xFF900000;
+                as->next_word_bytes = 2;
+                as->C += 0xFF00;
+                as->CT = 8;
+                return 0;
+            }
+
+            as->offset += as->next_word_bytes;
 
             B1 = (byte)((as->next_word >> 24) & 0xFF);
             if (B1 > 0x8F) {
@@ -97,7 +120,7 @@ jbig2_arith_bytein(Jbig2ArithState *as)
 #endif
                 as->CT = 8;
                 as->next_word = 0xFF000000 | (as->next_word >> 8);
-                as->next_word_bytes = 4;
+                as->next_word_bytes = 2;
                 as->offset--;
             } else {
 #ifdef JBIG2_DEBUG_ARITH
@@ -128,19 +151,35 @@ jbig2_arith_bytein(Jbig2ArithState *as)
 #ifdef JBIG2_DEBUG_ARITH
         fprintf(stderr, "read %02x\n", B);
 #endif
-        as->CT = 8;
         as->next_word <<= 8;
         as->next_word_bytes--;
+
         if (as->next_word_bytes == 0) {
-            Jbig2WordStream *ws = as->ws;
+            int ret = as->ws->get_next_word(ctx, as->ws, as->offset, &as->next_word);
+            if (ret < 0) {
+                as->err = 1;
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read from underlying stream during arithmetic decoding");
+            }
+            as->next_word_bytes = (size_t) ret;
 
-            new_bytes = ws->get_next_word(ws, as->offset, &as->next_word);
-            as->offset += new_bytes;
-            as->next_word_bytes = new_bytes;
+            if (as->next_word_bytes == 0) {
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to find terminating marker code before end of underlying stream, assuming terminating marker code");
+                as->next_word = 0xFF900000;
+                as->next_word_bytes = 2;
+                as->C += 0xFF00;
+                as->CT = 8;
+                return 0;
+            }
+
+            as->offset += as->next_word_bytes;
         }
+
         B = (byte)((as->next_word >> 24) & 0xFF);
         as->C += 0xFF00 - (B << 8);
+        as->CT = 8;
     }
+
+    return 0;
 }
 
 /** Allocate and initialize a new arithmetic coding state
@@ -151,24 +190,45 @@ Jbig2ArithState *
 jbig2_arith_new(Jbig2Ctx *ctx, Jbig2WordStream *ws)
 {
     Jbig2ArithState *result;
-    int new_bytes;
+    int ret;
 
     result = jbig2_new(ctx, Jbig2ArithState, 1);
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate arithmetic coding state");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate arithmetic coding state");
         return NULL;
     }
 
+    result->err = 0;
     result->ws = ws;
+    result->offset = 0;
+
+    ret = result->ws->get_next_word(ctx, result->ws, result->offset, &result->next_word);
+    if (ret < 0) {
+        jbig2_free(ctx->allocator, result);
+        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to initialize underlying stream of arithmetic decoder");
+        return NULL;
+    }
+
+    result->next_word_bytes = (size_t) ret;
+    if (result->next_word_bytes == 0) {
+        jbig2_free(ctx->allocator, result);
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read first byte from underlying stream when initializing arithmetic decoder");
+        return NULL;
+    }
 
-    new_bytes = ws->get_next_word(ws, 0, &result->next_word);
-    result->next_word_bytes = new_bytes;
-    result->offset = new_bytes;
+    result->offset += result->next_word_bytes;
 
-    /* Figure E.20 */
+    /* Figure F.1 */
     result->C = (~(result->next_word >> 8)) & 0xFF0000;
 
-    jbig2_arith_bytein(result);
+    /* Figure E.20 (2) */
+    if (jbig2_arith_bytein(ctx, result) < 0) {
+        jbig2_free(ctx->allocator, result);
+        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read second byte from underlying stream when initializing arithmetic decoder");
+        return NULL;
+    }
+
+    /* Figure E.20 (3) */
     result->C <<= 7;
     result->CT -= 7;
     result->A = 0x8000;
@@ -180,7 +240,7 @@ jbig2_arith_new(Jbig2Ctx *ctx, Jbig2Word
 
 /* could put bit fields in to minimize memory usage */
 typedef struct {
-    unsigned short Qe;
+    uint16_t Qe;
     byte mps_xor;               /* mps_xor = index ^ NMPS */
     byte lps_xor;               /* lps_xor = index ^ NLPS ^ (SWITCH << 7) */
 } Jbig2ArithQe;
@@ -235,33 +295,37 @@ static const Jbig2ArithQe jbig2_arith_Qe
     {0x5601, 46 ^ 46, 46 ^ 46}
 };
 
-static void
-jbig2_arith_renormd(Jbig2ArithState *as)
+static int
+jbig2_arith_renormd(Jbig2Ctx *ctx, Jbig2ArithState *as)
 {
     /* Figure E.18 */
     do {
-        if (as->CT == 0)
-            jbig2_arith_bytein(as);
+        if (as->CT == 0 && jbig2_arith_bytein(ctx, as) < 0) {
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read byte from compressed data stream");
+        }
         as->A <<= 1;
         as->C <<= 1;
         as->CT--;
     } while ((as->A & 0x8000) == 0);
+
+    return 0;
 }
 
 int
-jbig2_arith_decode(Jbig2ArithState *as, Jbig2ArithCx *pcx)
+jbig2_arith_decode(Jbig2Ctx *ctx, Jbig2ArithState *as, Jbig2ArithCx *pcx)
 {
     Jbig2ArithCx cx = *pcx;
     const Jbig2ArithQe *pqe;
     unsigned int index = cx & 0x7f;
     bool D;
 
-    if (index >= MAX_QE_ARRAY_SIZE)
-        return -1; /* Error */
+    if (index >= MAX_QE_ARRAY_SIZE) {
+        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to determine probability estimate because index out of range");
+    }
 
     pqe = &jbig2_arith_Qe[index];
 
-    /* Figure E.15 */
+    /* Figure F.2 */
     as->A -= pqe->Qe;
     if ((as->C >> 16) < as->A) {
         if ((as->A & 0x8000) == 0) {
@@ -273,7 +337,10 @@ jbig2_arith_decode(Jbig2ArithState *as,
                 D = cx >> 7;
                 *pcx ^= pqe->mps_xor;
             }
-            jbig2_arith_renormd(as);
+            if (jbig2_arith_renormd(ctx, as) < 0) {
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to renormalize decoder");
+            }
+
             return D;
         } else {
             return cx >> 7;
@@ -290,7 +357,10 @@ jbig2_arith_decode(Jbig2ArithState *as,
             D = 1 - (cx >> 7);
             *pcx ^= pqe->lps_xor;
         }
-        jbig2_arith_renormd(as);
+        if (jbig2_arith_renormd(ctx, as) < 0) {
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to renormalize decoder");
+        }
+
         return D;
     }
 }
@@ -313,7 +383,7 @@ jbig2_arith_trace(Jbig2ArithState *as, J
 #endif
 
 static int
-test_get_word(Jbig2WordStream *self, size_t offset, uint32_t *word)
+test_get_word(Jbig2Ctx *ctx, Jbig2WordStream *self, size_t offset, uint32_t *word)
 {
     uint32_t val = 0;
     int ret = 0;
@@ -362,11 +432,11 @@ main(int argc, char **argv)
 
     for (i = 0; i < 256; i++) {
 #ifdef JBIG2_DEBUG_ARITH
-        bool D =
+        int D =
 #else
         (void)
 #endif
-            jbig2_arith_decode(as, &cx);
+            jbig2_arith_decode(ctx, as, &cx);
 
 #ifdef JBIG2_DEBUG_ARITH
         fprintf(stderr, "%3d: D = %d, ", i, D);
diff -pruN 0.18-1/jbig2_arith.h 0.18+20200417-1/jbig2_arith.h
--- 0.18-1/jbig2_arith.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -32,7 +32,7 @@ Jbig2ArithState *jbig2_arith_new(Jbig2Ct
 
 /* decode a bit */
 /* Normally returns 0 or 1. May return negative in case of error. */
-int jbig2_arith_decode(Jbig2ArithState *as, Jbig2ArithCx *pcx);
+int jbig2_arith_decode(Jbig2Ctx *ctx, Jbig2ArithState *as, Jbig2ArithCx *pcx);
 
 /* returns true if the end of the data stream has been reached (for sanity checks) */
 bool jbig2_arith_has_reached_marker(Jbig2ArithState *as);
diff -pruN 0.18-1/jbig2_arith_iaid.c 0.18+20200417-1/jbig2_arith_iaid.c
--- 0.18-1/jbig2_arith_iaid.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith_iaid.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -37,18 +37,27 @@
 #include "jbig2_arith_iaid.h"
 
 struct _Jbig2ArithIaidCtx {
-    int SBSYMCODELEN;
+    uint8_t SBSYMCODELEN;
     Jbig2ArithCx *IAIDx;
 };
 
 Jbig2ArithIaidCtx *
-jbig2_arith_iaid_ctx_new(Jbig2Ctx *ctx, int SBSYMCODELEN)
+jbig2_arith_iaid_ctx_new(Jbig2Ctx *ctx, uint8_t SBSYMCODELEN)
 {
-    Jbig2ArithIaidCtx *result = jbig2_new(ctx, Jbig2ArithIaidCtx, 1);
-    int ctx_size = 1 << SBSYMCODELEN;
+    Jbig2ArithIaidCtx *result;
+    size_t ctx_size;
 
+    if (sizeof(ctx_size) * 8 <= SBSYMCODELEN)
+    {
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "requested IAID arithmetic coding state size too large");
+        return NULL;
+    }
+
+    ctx_size = (size_t) 1U << SBSYMCODELEN;
+
+    result = jbig2_new(ctx, Jbig2ArithIaidCtx, 1);
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate IAID arithmetic coding state");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate IAID arithmetic coding state");
         return NULL;
     }
 
@@ -57,7 +66,7 @@ jbig2_arith_iaid_ctx_new(Jbig2Ctx *ctx,
     if (result->IAIDx == NULL)
     {
         jbig2_free(ctx->allocator, result);
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate symbol ID in IAID arithmetic coding state");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate symbol ID in IAID arithmetic coding state");
         return NULL;
     }
 
@@ -71,16 +80,17 @@ int
 jbig2_arith_iaid_decode(Jbig2Ctx *ctx, Jbig2ArithIaidCtx *actx, Jbig2ArithState *as, int32_t *p_result)
 {
     Jbig2ArithCx *IAIDx = actx->IAIDx;
-    int SBSYMCODELEN = actx->SBSYMCODELEN;
+    uint8_t SBSYMCODELEN = actx->SBSYMCODELEN;
+    /* A.3 (1) */
     int PREV = 1;
     int D;
     int i;
 
     /* A.3 (2) */
     for (i = 0; i < SBSYMCODELEN; i++) {
-        D = jbig2_arith_decode(as, &IAIDx[PREV]);
+        D = jbig2_arith_decode(ctx, as, &IAIDx[PREV]);
         if (D < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAIDx code");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAIDx code");
 #ifdef VERBOSE
         fprintf(stderr, "IAID%x: D = %d\n", PREV, D);
 #endif
diff -pruN 0.18-1/jbig2_arith_iaid.h 0.18+20200417-1/jbig2_arith_iaid.h
--- 0.18-1/jbig2_arith_iaid.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith_iaid.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -22,7 +22,7 @@
 
 typedef struct _Jbig2ArithIaidCtx Jbig2ArithIaidCtx;
 
-Jbig2ArithIaidCtx *jbig2_arith_iaid_ctx_new(Jbig2Ctx *ctx, int SBSYMCODELEN);
+Jbig2ArithIaidCtx *jbig2_arith_iaid_ctx_new(Jbig2Ctx *ctx, uint8_t SBSYMCODELEN);
 
 int jbig2_arith_iaid_decode(Jbig2Ctx *ctx, Jbig2ArithIaidCtx *actx, Jbig2ArithState *as, int32_t *p_result);
 
diff -pruN 0.18-1/jbig2_arith_int.c 0.18+20200417-1/jbig2_arith_int.c
--- 0.18-1/jbig2_arith_int.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith_int.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -32,13 +32,6 @@
 #include "jbig2_arith.h"
 #include "jbig2_arith_int.h"
 
-#if !defined (INT32_MIN)
-#define INT32_MIN (-0x7fffffff - 1)
-#endif
-#if !defined (INT32_MAX)
-#define INT32_MAX  0x7fffffff
-#endif
-
 struct _Jbig2ArithIntCtx {
     Jbig2ArithCx IAx[512];
 };
@@ -49,7 +42,7 @@ jbig2_arith_int_ctx_new(Jbig2Ctx *ctx)
     Jbig2ArithIntCtx *result = jbig2_new(ctx, Jbig2ArithIntCtx, 1);
 
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate arithmetic integer coding state");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate arithmetic integer coding state");
         return NULL;
     } else {
         memset(result->IAx, 0, sizeof(result->IAx));
@@ -71,37 +64,37 @@ jbig2_arith_int_decode(Jbig2Ctx *ctx, Jb
     int n_tail, offset;
     int i;
 
-    S = jbig2_arith_decode(as, &IAx[PREV]);
+    S = jbig2_arith_decode(ctx, as, &IAx[PREV]);
     if (S < 0)
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx S");
+        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx S");
     PREV = (PREV << 1) | S;
 
-    bit = jbig2_arith_decode(as, &IAx[PREV]);
+    bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
     if (bit < 0)
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx decision bit 0");
+        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx decision bit 0");
     PREV = (PREV << 1) | bit;
     if (bit) {
-        bit = jbig2_arith_decode(as, &IAx[PREV]);
+        bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx decision bit 1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx decision bit 1");
         PREV = (PREV << 1) | bit;
 
         if (bit) {
-            bit = jbig2_arith_decode(as, &IAx[PREV]);
+            bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
             if (bit < 0)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx decision bit 2");
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx decision bit 2");
             PREV = (PREV << 1) | bit;
 
             if (bit) {
-                bit = jbig2_arith_decode(as, &IAx[PREV]);
+                bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx decision bit 3");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx decision bit 3");
                 PREV = (PREV << 1) | bit;
 
                 if (bit) {
-                    bit = jbig2_arith_decode(as, &IAx[PREV]);
+                    bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx decision bit 4");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx decision bit 4");
                     PREV = (PREV << 1) | bit;
 
                     if (bit) {
@@ -130,15 +123,18 @@ jbig2_arith_int_decode(Jbig2Ctx *ctx, Jb
 
     V = 0;
     for (i = 0; i < n_tail; i++) {
-        bit = jbig2_arith_decode(as, &IAx[PREV]);
+        bit = jbig2_arith_decode(ctx, as, &IAx[PREV]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode IAx V bit %d", i);
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode IAx V bit %d", i);
         PREV = ((PREV << 1) & 511) | (PREV & 256) | bit;
         V = (V << 1) | bit;
     }
 
-    /* make sure not to underflow/overflow 32 bit value */
-    if (V < INT32_MAX - 4436 || V > INT32_MIN + 4436)
+    /* offset is always >=0, so underflow can't happen. */
+    /* avoid overflow by clamping 32 bit value. */
+    if (V > INT32_MAX - offset)
+        V = INT32_MAX;
+    else
         V += offset;
     V = S ? -V : V;
     *p_result = V;
diff -pruN 0.18-1/jbig2_arith_int.h 0.18+20200417-1/jbig2_arith_int.h
--- 0.18-1/jbig2_arith_int.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_arith_int.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2.c 0.18+20200417-1/jbig2.c
--- 0.18-1/jbig2.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -71,12 +71,12 @@ jbig2_alloc(Jbig2Allocator *allocator, s
 /* jbig2_free and jbig2_realloc moved to the bottom of this file */
 
 static void
-jbig2_default_error(void *data, const char *msg, Jbig2Severity severity, int32_t seg_idx)
+jbig2_default_error(void *data, const char *msg, Jbig2Severity severity, uint32_t seg_idx)
 {
     /* report only fatal errors by default */
     if (severity == JBIG2_SEVERITY_FATAL) {
         fprintf(stderr, "jbig2 decoder FATAL ERROR: %s", msg);
-        if (seg_idx != -1)
+        if (seg_idx != JBIG2_UNKNOWN_SEGMENT_NUMBER)
             fprintf(stderr, " (segment 0x%02x)", seg_idx);
         fprintf(stderr, "\n");
         fflush(stderr);
@@ -84,7 +84,7 @@ jbig2_default_error(void *data, const ch
 }
 
 int
-jbig2_error(Jbig2Ctx *ctx, Jbig2Severity severity, int32_t segment_number, const char *fmt, ...)
+jbig2_error(Jbig2Ctx *ctx, Jbig2Severity severity, uint32_t segment_number, const char *fmt, ...)
 {
     char buf[1024];
     va_list ap;
@@ -108,7 +108,7 @@ jbig2_ctx_new_imp(Jbig2Allocator *alloca
         Jbig2Ctx fakectx;
         fakectx.error_callback = error_callback;
         fakectx.error_callback_data = error_callback_data;
-        jbig2_error(&fakectx, JBIG2_SEVERITY_FATAL, -1, "incompatible jbig2dec header (%d.%d) and library (%d.%d) versions",
+        jbig2_error(&fakectx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "incompatible jbig2dec header (%d.%d) and library (%d.%d) versions",
             jbig2_version_major, jbig2_version_minor, JBIG2_VERSION_MAJOR, JBIG2_VERSION_MINOR);
         return NULL;
     }
@@ -120,7 +120,7 @@ jbig2_ctx_new_imp(Jbig2Allocator *alloca
 
     result = (Jbig2Ctx *) jbig2_alloc(allocator, sizeof(Jbig2Ctx), 1);
     if (result == NULL) {
-        error_callback(error_callback_data, "failed to allocate initial context", JBIG2_SEVERITY_FATAL, -1);
+        error_callback(error_callback_data, "failed to allocate initial context", JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER);
         return NULL;
     }
 
@@ -138,7 +138,7 @@ jbig2_ctx_new_imp(Jbig2Allocator *alloca
     result->n_segments_max = 16;
     result->segments = jbig2_new(result, Jbig2Segment *, result->n_segments_max);
     if (result->segments == NULL) {
-        error_callback(error_callback_data, "failed to allocate initial segments", JBIG2_SEVERITY_FATAL, -1);
+        error_callback(error_callback_data, "failed to allocate initial segments", JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER);
         jbig2_free(allocator, result);
         return NULL;
     }
@@ -148,13 +148,13 @@ jbig2_ctx_new_imp(Jbig2Allocator *alloca
     result->max_page_index = 4;
     result->pages = jbig2_new(result, Jbig2Page, result->max_page_index);
     if (result->pages == NULL) {
-        error_callback(error_callback_data, "failed to allocated initial pages", JBIG2_SEVERITY_FATAL, -1);
+        error_callback(error_callback_data, "failed to allocated initial pages", JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER);
         jbig2_free(allocator, result->segments);
         jbig2_free(allocator, result);
         return NULL;
     }
     {
-        int index;
+        uint32_t index;
 
         for (index = 0; index < result->max_page_index; index++) {
             result->pages[index].state = JBIG2_PAGE_FREE;
@@ -211,6 +211,22 @@ jbig2_get_uint32(const byte *bptr)
     return ((uint32_t) get_uint16(bptr) << 16) | get_uint16(bptr + 2);
 }
 
+static size_t
+jbig2_find_buffer_size(size_t desired)
+{
+    const size_t initial_buf_size = 1024;
+    size_t size = initial_buf_size;
+
+    if (desired == SIZE_MAX)
+        return SIZE_MAX;
+
+    while (size < desired)
+        size <<= 1;
+
+    return size;
+}
+
+
 /**
  * jbig2_data_in: submit data for decoding
  * @ctx: The jbig2dec decoder context
@@ -226,36 +242,35 @@ jbig2_get_uint32(const byte *bptr)
 int
 jbig2_data_in(Jbig2Ctx *ctx, const unsigned char *data, size_t size)
 {
-    const size_t initial_buf_size = 1024;
-
     if (ctx->buf == NULL) {
-        size_t buf_size = initial_buf_size;
-
-        do
-            buf_size <<= 1;
-        while (buf_size < size);
+        size_t buf_size = jbig2_find_buffer_size(size);
         ctx->buf = jbig2_new(ctx, byte, buf_size);
         if (ctx->buf == NULL) {
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate buffer when reading data");
+            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate buffer when reading data");
         }
         ctx->buf_size = buf_size;
         ctx->buf_rd_ix = 0;
         ctx->buf_wr_ix = 0;
-    } else if (ctx->buf_wr_ix + size > ctx->buf_size) {
-        if (ctx->buf_rd_ix <= (ctx->buf_size >> 1) && ctx->buf_wr_ix - ctx->buf_rd_ix + size <= ctx->buf_size) {
-            memmove(ctx->buf, ctx->buf + ctx->buf_rd_ix, ctx->buf_wr_ix - ctx->buf_rd_ix);
+    } else if (size > ctx->buf_size - ctx->buf_wr_ix) {
+        size_t already = ctx->buf_wr_ix - ctx->buf_rd_ix;
+
+        if (ctx->buf_rd_ix <= (ctx->buf_size >> 1) && size <= ctx->buf_size - already) {
+            memmove(ctx->buf, ctx->buf + ctx->buf_rd_ix, already);
         } else {
             byte *buf;
-            size_t buf_size = initial_buf_size;
+            size_t buf_size;
+
+            if (already > SIZE_MAX - size) {
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "read data causes buffer to grow too large");
+            }
+
+            buf_size = jbig2_find_buffer_size(size + already);
 
-            do
-                buf_size <<= 1;
-            while (buf_size < ctx->buf_wr_ix - ctx->buf_rd_ix + size);
             buf = jbig2_new(ctx, byte, buf_size);
             if (buf == NULL) {
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate bigger buffer when reading data");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate bigger buffer when reading data");
             }
-            memcpy(buf, ctx->buf + ctx->buf_rd_ix, ctx->buf_wr_ix - ctx->buf_rd_ix);
+            memcpy(buf, ctx->buf + ctx->buf_rd_ix, already);
             jbig2_free(ctx->allocator, ctx->buf);
             ctx->buf = buf;
             ctx->buf_size = buf_size;
@@ -263,6 +278,7 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
         ctx->buf_wr_ix -= ctx->buf_rd_ix;
         ctx->buf_rd_ix = 0;
     }
+
     memcpy(ctx->buf + ctx->buf_wr_ix, data, size);
     ctx->buf_wr_ix += size;
 
@@ -280,17 +296,17 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
             if (ctx->buf_wr_ix - ctx->buf_rd_ix < 9)
                 return 0;
             if (memcmp(ctx->buf + ctx->buf_rd_ix, jbig2_id_string, 8))
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "not a JBIG2 file header");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "not a JBIG2 file header");
             /* D.4.2 */
             ctx->file_header_flags = ctx->buf[ctx->buf_rd_ix + 8];
             /* Check for T.88 amendment 2 */
             if (ctx->file_header_flags & 0x04)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "file header indicates use of 12 adaptive template pixels (NYI)");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates use of 12 adaptive template pixels (NYI)");
             /* Check for T.88 amendment 3 */
             if (ctx->file_header_flags & 0x08)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "file header indicates use of colored region segments (NYI)");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates use of colored region segments (NYI)");
             if (ctx->file_header_flags & 0xFC) {
-                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "reserved bits (2-7) of file header flags are not zero (0x%02x)", ctx->file_header_flags);
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "reserved bits (2-7) of file header flags are not zero (0x%02x)", ctx->file_header_flags);
             }
             /* D.4.3 */
             if (!(ctx->file_header_flags & 2)) {        /* number of pages is known */
@@ -299,9 +315,9 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
                 ctx->n_pages = jbig2_get_uint32(ctx->buf + ctx->buf_rd_ix + 9);
                 ctx->buf_rd_ix += 13;
                 if (ctx->n_pages == 1)
-                    jbig2_error(ctx, JBIG2_SEVERITY_INFO, -1, "file header indicates a single page document");
+                    jbig2_error(ctx, JBIG2_SEVERITY_INFO, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates a single page document");
                 else
-                    jbig2_error(ctx, JBIG2_SEVERITY_INFO, -1, "file header indicates a %d page document", ctx->n_pages);
+                    jbig2_error(ctx, JBIG2_SEVERITY_INFO, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates a %d page document", ctx->n_pages);
             } else {            /* number of pages not known */
                 ctx->n_pages = 0;
                 ctx->buf_rd_ix += 9;
@@ -309,10 +325,10 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
             /* determine the file organization based on the flags - D.4.2 again */
             if (ctx->file_header_flags & 1) {
                 ctx->state = JBIG2_FILE_SEQUENTIAL_HEADER;
-                jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "file header indicates sequential organization");
+                jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates sequential organization");
             } else {
                 ctx->state = JBIG2_FILE_RANDOM_HEADERS;
-                jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "file header indicates random-access organization");
+                jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "file header indicates random-access organization");
             }
             break;
         case JBIG2_FILE_SEQUENTIAL_HEADER:
@@ -322,9 +338,17 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
                 return 0; /* need more data */
             ctx->buf_rd_ix += header_size;
 
-            if (ctx->n_segments == ctx->n_segments_max) {
+            if (ctx->n_segments >= ctx->n_segments_max) {
                 Jbig2Segment **segments;
 
+                if (ctx->n_segments_max == UINT32_MAX) {
+                    ctx->state = JBIG2_FILE_EOF;
+                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "too many segments in jbig2 image");
+                }
+                else if (ctx->n_segments_max > (UINT32_MAX >> 2)) {
+                    ctx->n_segments_max = UINT32_MAX;
+                }
+
                 segments = jbig2_renew(ctx, ctx->segments, Jbig2Segment *, (ctx->n_segments_max <<= 2));
                 if (segments == NULL) {
                     ctx->state = JBIG2_FILE_EOF;
@@ -333,7 +357,6 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
                 ctx->segments = segments;
             }
 
-
             ctx->segments[ctx->n_segments++] = segment;
             if (ctx->state == JBIG2_FILE_RANDOM_HEADERS) {
                 if ((segment->flags & 63) == 51)        /* end of file */
@@ -380,7 +403,7 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
                 segment->rows = jbig2_get_uint32(p);
                 p += 4;
 
-                segment->data_length = p - s;
+                segment->data_length = (size_t) (p - s);
                 jbig2_error(ctx, JBIG2_SEVERITY_INFO, segment->number, "unknown length determined to be %lu", (long) segment->data_length);
             }
             else if (segment->data_length > ctx->buf_wr_ix - ctx->buf_rd_ix)
@@ -403,7 +426,7 @@ jbig2_data_in(Jbig2Ctx *ctx, const unsig
         case JBIG2_FILE_EOF:
             if (ctx->buf_rd_ix == ctx->buf_wr_ix)
                 return 0;
-            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "garbage beyond end of file");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "garbage beyond end of file");
         }
     }
 }
@@ -412,7 +435,7 @@ Jbig2Allocator *
 jbig2_ctx_free(Jbig2Ctx *ctx)
 {
     Jbig2Allocator *ca;
-    int i;
+    uint32_t i;
 
     if (ctx == NULL)
         return NULL;
@@ -461,29 +484,30 @@ typedef struct {
 } Jbig2WordStreamBuf;
 
 static int
-jbig2_word_stream_buf_get_next_word(Jbig2WordStream *self, size_t offset, uint32_t *word)
+jbig2_word_stream_buf_get_next_word(Jbig2Ctx *ctx, Jbig2WordStream *self, size_t offset, uint32_t *word)
 {
     Jbig2WordStreamBuf *z = (Jbig2WordStreamBuf *) self;
     uint32_t val = 0;
     int ret = 0;
 
-    if (self == NULL || word == NULL)
-        return -1;
+    if (self == NULL || word == NULL) {
+        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read next word of stream because stream or output missing");
+    }
     if (offset >= z->size) {
         *word = 0;
         return 0;
     }
 
     if (offset < z->size) {
-        val |= z->data[offset] << 24;
+        val = (uint32_t) z->data[offset] << 24;
         ret++;
     }
     if (offset + 1 < z->size) {
-        val |= z->data[offset + 1] << 16;
+        val |= (uint32_t) z->data[offset + 1] << 16;
         ret++;
     }
     if (offset + 2 < z->size) {
-        val |= z->data[offset + 2] << 8;
+        val |= (uint32_t) z->data[offset + 2] << 8;
         ret++;
     }
     if (offset + 3 < z->size) {
@@ -500,7 +524,7 @@ jbig2_word_stream_buf_new(Jbig2Ctx *ctx,
     Jbig2WordStreamBuf *result = jbig2_new(ctx, Jbig2WordStreamBuf, 1);
 
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate word stream");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate word stream");
         return NULL;
     }
 
diff -pruN 0.18-1/jbig2dec.1 0.18+20200417-1/jbig2dec.1
--- 0.18-1/jbig2dec.1	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2dec.1	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-.TH jbig2dec 1 "2020 February 11" "Version 0.18" "jbig2dec Manual"
+.TH jbig2dec 1 "2020 March 11" "Version 0.18" "jbig2dec Manual"
 
 .SH NAME
 jbig2dec \- File format converter specialized in JBIG2 decoding
@@ -32,35 +32,38 @@ argument to request the embedded parser.
 .SH OPTIONS
 The options are as follows:
 .TP
-.BI -o " file"
+.BR -e ", " --embedded
+Expect embedded bit stream without file header.
+.TP
+.BI -o " file" ", --output" " file"
 Store the decoded output in
 .IR file .
 Defaults to the input with a different extension.
 Set to \fI-\fR for standard output.
 .TP
-.BI -t " type"
+.BI -t " type" ", --format" " type"
 Force a particular output file format. Supported are \fIpng\fR and
 \fIpbm\fR.
 .TP
-.BR -d " or " --dump
+.BR -d ", " --dump
 Print the structure of the JBIG2 file rather than explicitly decoding it.
 .TP
-.BR --hash
+.BR -m ", " --hash
 Print a hash of the decoded document.
 .TP
-.BR -q " or " --quiet
+.BR -q ", " --quiet
 Suppress warnings and other diagnostic output.
 .TP
-.BR -v " or " --verbose
+.BR -v ", " --verbose
 Report additional information about the decoding process.
 Pass just \fB-v\fR for information about the file as it's being decoded.
 This is the same as \fB--verbose=2\fR.
 Pass \fB--verbose=3\fR or higher for debugging information.
 .TP
-.BR --version
+.BR -V ", " --version
 Show program version information.
 .TP
-.BR -h " or " --help
+.BR -h ", " --help
 Show usage summary.
 
 .SH REPORTING BUGS
diff -pruN 0.18-1/jbig2dec.c 0.18+20200417-1/jbig2dec.c
--- 0.18-1/jbig2dec.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2dec.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -65,15 +65,129 @@ typedef struct {
     SHA1_CTX *hash_ctx;
     char *output_filename;
     jbig2dec_format output_format;
+    size_t memory_limit;
+} jbig2dec_params_t;
+
+typedef struct {
+    int verbose;
     char *last_message;
     Jbig2Severity severity;
     char *type;
     long repeats;
-} jbig2dec_params_t;
+} jbig2dec_error_callback_state_t;
+
+typedef struct {
+    Jbig2Allocator super;
+    Jbig2Ctx *ctx;
+    size_t memory_limit;
+    size_t memory_used;
+    size_t memory_peak;
+} jbig2dec_allocator_t;
 
 static int print_version(void);
 static int print_usage(void);
 
+#define ALIGNMENT 16
+#define KBYTE 1024
+#define MBYTE (1024 * KBYTE)
+
+static void *jbig2dec_alloc(Jbig2Allocator *allocator_, size_t size)
+{
+    jbig2dec_allocator_t *allocator = (jbig2dec_allocator_t *) allocator_;
+    void *ptr;
+
+    if (size == 0)
+        return NULL;
+    if (size > allocator->memory_limit - ALIGNMENT - allocator->memory_used)
+        return NULL;
+
+    ptr = malloc(size + ALIGNMENT);
+    if (ptr == NULL)
+        return NULL;
+    memcpy(ptr, &size, sizeof(size));
+    allocator->memory_used += size + ALIGNMENT;
+
+    if (allocator->memory_used > allocator->memory_peak) {
+        allocator->memory_peak = allocator->memory_used;
+
+        if (allocator->ctx) {
+            size_t limit_mb = allocator->memory_limit / MBYTE;
+            size_t peak_mb = allocator->memory_peak / MBYTE;
+            jbig2_error(allocator->ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "memory: limit: %lu Mbyte peak usage: %lu Mbyte", limit_mb, peak_mb);
+        }
+    }
+
+    return (unsigned char *) ptr + ALIGNMENT;
+}
+
+static void jbig2dec_free(Jbig2Allocator *allocator_, void *p)
+{
+    jbig2dec_allocator_t *allocator = (jbig2dec_allocator_t *) allocator_;
+    size_t size;
+
+    if (p == NULL)
+        return;
+
+    memcpy(&size, (unsigned char *) p - ALIGNMENT, sizeof(size));
+    allocator->memory_used -= size + ALIGNMENT;
+    free((unsigned char *) p - ALIGNMENT);
+}
+
+static void *jbig2dec_realloc(Jbig2Allocator *allocator_, void *p, size_t size)
+{
+    jbig2dec_allocator_t *allocator = (jbig2dec_allocator_t *) allocator_;
+    unsigned char *oldp = p ? (unsigned char *) p - ALIGNMENT : NULL;
+
+    if (size > SIZE_MAX - ALIGNMENT)
+        return NULL;
+
+    if (oldp == NULL)
+    {
+        if (size == 0)
+            return NULL;
+        if (size > allocator->memory_limit - ALIGNMENT - allocator->memory_used)
+            return NULL;
+
+        p = malloc(size + ALIGNMENT);
+    }
+    else
+    {
+        size_t oldsize;
+        memcpy(&oldsize, oldp, sizeof(oldsize));
+
+        if (size == 0)
+        {
+            allocator->memory_used -= oldsize + ALIGNMENT;
+            free(oldp);
+            return NULL;
+        }
+
+        if (size > allocator->memory_limit - allocator->memory_used + oldsize)
+            return NULL;
+
+        p = realloc(oldp, size + ALIGNMENT);
+        if (p == NULL)
+            return NULL;
+
+        allocator->memory_used -= oldsize + ALIGNMENT;
+    }
+
+    memcpy(p, &size, sizeof(size));
+    allocator->memory_used += size + ALIGNMENT;
+
+    if (allocator->memory_used > allocator->memory_peak) {
+        allocator->memory_peak = allocator->memory_used;
+
+        if (allocator->ctx) {
+            size_t limit_mb = allocator->memory_limit / MBYTE;
+            size_t peak_mb = allocator->memory_peak / MBYTE;
+            jbig2_error(allocator->ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "memory: limit: %lu Mbyte peak usage: %lu Mbyte", limit_mb, peak_mb);
+        }
+    }
+
+    return (unsigned char *) p + ALIGNMENT;
+}
+
 /* page hashing functions */
 static void
 hash_init(jbig2dec_params_t *params)
@@ -151,9 +265,10 @@ parse_options(int argc, char *argv[], jb
     };
     int option_idx = 1;
     int option;
+    int ret;
 
     while (1) {
-        option = getopt_long(argc, argv, "Vh?qv:do:t:e", long_options, &option_idx);
+        option = getopt_long(argc, argv, "Vh?qv:do:t:eM:", long_options, &option_idx);
         if (option == -1)
             break;
 
@@ -196,9 +311,14 @@ parse_options(int argc, char *argv[], jb
         case 'e':
             params->embedded = 1;
             break;
+        case 'M':
+            ret = sscanf(optarg, "%zu", &params->memory_limit);
+            if (ret != 1)
+                fprintf(stderr, "could not parse memory limit argument\n");
+            break;
         default:
             if (!params->verbose)
-                fprintf(stdout, "unrecognized option: -%c\n", option);
+                fprintf(stderr, "unrecognized option: -%c\n", option);
             break;
         }
     }
@@ -226,22 +346,25 @@ print_usage(void)
             "  embedded streams.\n"
             "\n"
             "  available options:\n"
-            "    -h --help      this usage summary\n"
-            "    -q --quiet     suppress diagnostic output\n"
-            "    -v --verbose   set the verbosity level\n"
-            "    -d --dump      print the structure of the jbig2 file\n"
-            "                   rather than explicitly decoding\n"
-            "       --version   program name and version information\n"
-            "       --hash      print a hash of the decoded document\n"
-            "    -e --embedded  expect embedded bit stream without file header\n"
-            "    -o <file>      send decoded output to <file>\n"
-            "                   Defaults to the the input with a different\n"
-            "                   extension. Pass '-' for stdout.\n"
-            "    -t <type>      force a particular output file format\n"
+            "    -h --help       this usage summary\n"
+            "    -q --quiet      suppress diagnostic output\n"
+            "    -v --verbose    set the verbosity level\n"
+            "    -d --dump       print the structure of the jbig2 file\n"
+            "                    rather than explicitly decoding\n"
+            "    -V --version    program name and version information\n"
+            "    -m --hash       print a hash of the decoded document\n"
+            "    -e --embedded   expect embedded bit stream without file header\n"
+            "    -M <limit>      memory limit expressed in bytes\n"
+            "    -o <file>\n"
+            "    --output <file> send decoded output to <file>\n"
+            "                    Defaults to the the input with a different\n"
+            "                    extension. Pass '-' for stdout.\n"
+            "    -t <type>\n"
+            "    --format <type> force a particular output file format\n"
 #ifdef HAVE_LIBPNG
-            "                   supported options are 'png' and 'pbm'\n"
+            "                    supported options are 'png' and 'pbm'\n"
 #else
-            "                   the only supported option is 'pbm'\n"
+            "                    the only supported option is 'pbm'\n"
 #endif
             "\n");
 
@@ -249,27 +372,25 @@ print_usage(void)
 }
 
 static void
-error_callback(void *error_callback_data, const char *buf, Jbig2Severity severity, int32_t seg_idx)
+error_callback(void *error_callback_data, const char *message, Jbig2Severity severity, uint32_t seg_idx)
 {
-    jbig2dec_params_t *params = (jbig2dec_params_t *) error_callback_data;
+    jbig2dec_error_callback_state_t *state = (jbig2dec_error_callback_state_t *) error_callback_data;
     char *type;
-    char segment[22];
-    int len;
-    char *message;
+    int ret;
 
     switch (severity) {
     case JBIG2_SEVERITY_DEBUG:
-        if (params->verbose < 3)
+        if (state->verbose < 3)
             return;
         type = "DEBUG";
         break;
     case JBIG2_SEVERITY_INFO:
-        if (params->verbose < 2)
+        if (state->verbose < 2)
             return;
         type = "info";
         break;
     case JBIG2_SEVERITY_WARNING:
-        if (params->verbose < 1)
+        if (state->verbose < 1)
             return;
         type = "WARNING";
         break;
@@ -280,56 +401,58 @@ error_callback(void *error_callback_data
         type = "unknown message";
         break;
     }
-    if (seg_idx == -1)
-        segment[0] = '\0';
-    else
-        snprintf(segment, sizeof(segment), "(segment 0x%02x)", seg_idx);
 
-    len = snprintf(NULL, 0, "jbig2dec %s %s %s", type, buf, segment);
-    if (len < 0) {
-        return;
-    }
+    if (state->last_message != NULL && !strcmp(message, state->last_message) && state->severity == severity && state->type == type) {
+        state->repeats++;
+        if (state->repeats % 1000000 == 0) {
+            ret = fprintf(stderr, "jbig2dec %s last message repeated %ld times so far\n", state->type, state->repeats);
+            if (ret < 0)
+                goto printerror;
+        }
+    } else {
+        if (state->repeats > 1) {
+            ret = fprintf(stderr, "jbig2dec %s last message repeated %ld times\n", state->type, state->repeats);
+            if (ret < 0)
+                goto printerror;
+        }
 
-    message = malloc(len + 1);
-    if (message == NULL) {
-        return;
+        if (seg_idx == JBIG2_UNKNOWN_SEGMENT_NUMBER)
+            ret = fprintf(stderr, "jbig2dec %s %s\n", type, message);
+        else
+            ret = fprintf(stderr, "jbig2dec %s %s (segment 0x%08x)\n", type, message, seg_idx);
+        if (ret < 0)
+            goto printerror;
+
+        state->repeats = 0;
+        state->severity = severity;
+        state->type = type;
+        free(state->last_message);
+        state->last_message = NULL;
+
+        if (message) {
+            state->last_message = strdup(message);
+            if (state->last_message == NULL) {
+                ret = fprintf(stderr, "jbig2dec WARNING could not duplicate message\n");
+                if (ret < 0)
+                    goto printerror;
+            }
+        }
     }
 
-    len = snprintf(message, len + 1, "jbig2dec %s %s %s", type, buf, segment);
-    if (len < 0)
-    {
-        free(message);
-        return;
-    }
+    return;
 
-    if (params->last_message != NULL && strcmp(message, params->last_message)) {
-        if (params->repeats > 1)
-            fprintf(stderr, "jbig2dec %s last message repeated %ld times\n", params->type, params->repeats);
-        fprintf(stderr, "%s\n", message);
-        free(params->last_message);
-        params->last_message = message;
-        params->severity = severity;
-        params->type = type;
-        params->repeats = 0;
-    } else if (params->last_message != NULL) {
-        params->repeats++;
-        if (params->repeats % 1000000 == 0)
-            fprintf(stderr, "jbig2dec %s last message repeated %ld times so far\n", params->type, params->repeats);
-        free(message);
-    } else if (params->last_message == NULL) {
-        fprintf(stderr, "%s\n", message);
-        params->last_message = message;
-        params->severity = severity;
-        params->type = type;
-        params->repeats = 0;
-    }
+printerror:
+    fprintf(stderr, "jbig2dec WARNING could not print message\n");
+    state->repeats = 0;
+    free(state->last_message);
+    state->last_message = NULL;
 }
 
 static void
-flush_errors(jbig2dec_params_t *params)
+flush_errors(jbig2dec_error_callback_state_t *state)
 {
-    if (params->repeats > 1) {
-        fprintf(stderr, "jbig2dec last message repeated %ld times\n", params->repeats);
+    if (state->repeats > 1) {
+        fprintf(stderr, "jbig2dec last message repeated %ld times\n", state->repeats);
     }
 }
 
@@ -338,7 +461,7 @@ make_output_filename(const char *input_f
 {
     char *output_filename;
     const char *c, *e;
-    int len;
+    size_t extlen, len;
 
     if (extension == NULL) {
         fprintf(stderr, "no filename extension; cannot create output filename!\n");
@@ -368,16 +491,18 @@ make_output_filename(const char *input_f
     if (e != NULL)
         len -= strlen(e);
 
+    extlen = strlen(extension);
+
     /* allocate enough space for the base + ext */
-    output_filename = (char *)malloc(len + strlen(extension) + 1);
+    output_filename = (char *)malloc(len + extlen + 1);
     if (output_filename == NULL) {
         fprintf(stderr, "failed to allocate memory for output filename\n");
         exit(1);
     }
 
-    strncpy(output_filename, c, len);
-    strncpy(output_filename + len, extension, strlen(extension));
-    *(output_filename + len + strlen(extension)) = '\0';
+    memcpy(output_filename, c, len);
+    memcpy(output_filename + len, extension, extlen);
+    *(output_filename + len + extlen) = '\0';
 
     /* return the new string */
     return (output_filename);
@@ -422,10 +547,13 @@ write_document_hash(jbig2dec_params_t *p
 int
 main(int argc, char **argv)
 {
-    FILE *f = NULL, *f_page = NULL;
+    jbig2dec_params_t params;
+    jbig2dec_error_callback_state_t error_callback_state;
+    jbig2dec_allocator_t allocator_;
+    jbig2dec_allocator_t *allocator = &allocator_;
     Jbig2Ctx *ctx = NULL;
+    FILE *f = NULL, *f_page = NULL;
     uint8_t buf[4096];
-    jbig2dec_params_t params;
     int filearg;
     int result = 1;
     int code;
@@ -437,11 +565,16 @@ main(int argc, char **argv)
     params.output_filename = NULL;
     params.output_format = jbig2dec_format_none;
     params.embedded = 0;
-    params.last_message = NULL;
-    params.repeats = 0;
+    params.memory_limit = 0;
 
     filearg = parse_options(argc, argv, &params);
 
+    error_callback_state.verbose = params.verbose;
+    error_callback_state.severity = JBIG2_SEVERITY_DEBUG;
+    error_callback_state.type = NULL;
+    error_callback_state.last_message = NULL;
+    error_callback_state.repeats = 0;
+
     if (params.hash)
         hash_init(&params);
 
@@ -487,7 +620,20 @@ main(int argc, char **argv)
             goto cleanup;
         }
 
-        ctx = jbig2_ctx_new(NULL, (Jbig2Options)(f_page != NULL || params.embedded ? JBIG2_OPTIONS_EMBEDDED : 0), NULL, error_callback, &params);
+        if (params.memory_limit == 0)
+            allocator = NULL;
+        else
+        {
+            allocator->super.alloc = jbig2dec_alloc;
+            allocator->super.free = jbig2dec_free;
+            allocator->super.realloc = jbig2dec_realloc;
+            allocator->ctx = NULL;
+            allocator->memory_limit = params.memory_limit;
+            allocator->memory_used = 0;
+            allocator->memory_peak = 0;
+        }
+
+        ctx = jbig2_ctx_new((Jbig2Allocator *) allocator, (Jbig2Options)(f_page != NULL || params.embedded ? JBIG2_OPTIONS_EMBEDDED : 0), NULL, error_callback, &error_callback_state);
         if (ctx == NULL) {
             fclose(f);
             if (f_page)
@@ -495,14 +641,29 @@ main(int argc, char **argv)
             goto cleanup;
         }
 
+        if (allocator != NULL)
+            allocator->ctx = ctx;
+
         /* pull the whole file/global stream into memory */
         for (;;) {
             int n_bytes = fread(buf, 1, sizeof(buf), f);
-
+            if (n_bytes < 0) {
+                if (f_page != NULL)
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to read jbig2 global stream");
+                else
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to read jbig2 page stream");
+            }
             if (n_bytes <= 0)
                 break;
-            if (jbig2_data_in(ctx, buf, n_bytes))
+
+            if (jbig2_data_in(ctx, buf, (size_t) n_bytes) < 0)
+            {
+                if (f_page != NULL)
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to process jbig2 global stream");
+                else
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to process jbig2 page stream");
                 break;
+            }
         }
         fclose(f);
 
@@ -510,15 +671,23 @@ main(int argc, char **argv)
         if (f_page != NULL) {
             Jbig2GlobalCtx *global_ctx = jbig2_make_global_ctx(ctx);
 
-            ctx = jbig2_ctx_new(NULL, JBIG2_OPTIONS_EMBEDDED, global_ctx, error_callback, &params);
+            ctx = jbig2_ctx_new((Jbig2Allocator *) allocator, JBIG2_OPTIONS_EMBEDDED, global_ctx, error_callback, &error_callback_state);
             if (ctx != NULL) {
+                if (allocator != NULL)
+                    allocator->ctx = ctx;
+
                 for (;;) {
                     int n_bytes = fread(buf, 1, sizeof(buf), f_page);
-
+                    if (n_bytes < 0)
+                        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to read jbig2 page stream");
                     if (n_bytes <= 0)
                         break;
-                    if (jbig2_data_in(ctx, buf, n_bytes))
+
+                    if (jbig2_data_in(ctx, buf, (size_t) n_bytes) < 0)
+                    {
+                        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to process jbig2 page stream");
                         break;
+                    }
                 }
             }
             fclose(f_page);
@@ -535,7 +704,7 @@ main(int argc, char **argv)
             with parse errors. */
             code = jbig2_complete_page(ctx);
             if (code < 0) {
-                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "unable to complete page");
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to complete page");
                 goto cleanup;
             }
 
@@ -586,19 +755,24 @@ main(int argc, char **argv)
                 write_document_hash(&params);
         }
 
-
     }                           /* end params.mode switch */
 
+    if (allocator != NULL && allocator->ctx != NULL) {
+        size_t limit_mb = allocator->memory_limit / MBYTE;
+        size_t peak_mb = allocator->memory_peak / MBYTE;
+        jbig2_error(allocator->ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "memory: limit: %lu Mbyte peak usage: %lu Mbyte", limit_mb, peak_mb);
+    }
+
     /* fin */
     result = 0;
 
 cleanup:
-    flush_errors(&params);
+    flush_errors(&error_callback_state);
     jbig2_ctx_free(ctx);
-    if (params.last_message)
-        free(params.last_message);
     if (params.output_filename)
         free(params.output_filename);
+    if (error_callback_state.last_message)
+        free(error_callback_state.last_message);
     if (params.hash)
         hash_free(&params);
 
diff -pruN 0.18-1/jbig2_generic.c 0.18+20200417-1/jbig2_generic.c
--- 0.18-1/jbig2_generic.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_generic.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -42,10 +42,6 @@
 #include "jbig2_page.h"
 #include "jbig2_segment.h"
 
-#if !defined (UINT32_MAX)
-#define UINT32_MAX 0xffffffff
-#endif
-
 /*
 This is an explanation of the unoptimized and optimized generic
 region decoder implementations below, wherein we try to explain
@@ -412,9 +408,9 @@ jbig2_decode_generic_template0(Jbig2Ctx
             for (x_minor = 0; x_minor < minor_width; x_minor++) {
                 int bit;
 
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 optimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 optimized");
                 result |= bit << (7 - x_minor);
                 CONTEXT = ((CONTEXT & 0x7bf7) << 1) | bit | ((line_m1 >> (7 - x_minor)) & 0x10) | ((line_m2 >> (7 - x_minor)) & 0x800);
             }
@@ -481,9 +477,9 @@ jbig2_decode_generic_template0_unopt(Jbi
                 CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[4], y + params->gbat[5]) << 11;
                 CONTEXT |= (ppd>>2) & 0x7000; /* Next 3 pixels */
                 CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[6], y + params->gbat[7]) << 15;
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 unoptimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 unoptimized");
             }
             pd = pd<<1;
             ppd = ppd<<1;
@@ -547,9 +543,9 @@ jbig2_decode_generic_template1_unopt(Jbi
                 CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 3;
                 CONTEXT |= (pd>>9) & 0x01F0; /* Next 5 pixels */
                 CONTEXT |= (ppd>>4) & 0x1E00; /* Next 4 pixels */
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template1 unoptimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template1 unoptimized");
             }
             pd = pd<<1;
             ppd = ppd<<1;
@@ -618,9 +614,9 @@ jbig2_decode_generic_template1(Jbig2Ctx
             for (x_minor = 0; x_minor < minor_width; x_minor++) {
                 int bit;
 
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template1 optimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template1 optimized");
                 result |= bit << (7 - x_minor);
                 CONTEXT = ((CONTEXT & 0xefb) << 1) | bit | ((line_m1 >> (8 - x_minor)) & 0x8) | ((line_m2 >> (8 - x_minor)) & 0x200);
             }
@@ -678,9 +674,9 @@ jbig2_decode_generic_template2_unopt(Jbi
                 CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 2;
                 CONTEXT |= (pd>>11) & 0x078; /* Next 4 pixels */
                 CONTEXT |= (ppd>>7) & 0x380; /* Next 3 pixels */
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template2 unoptimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template2 unoptimized");
             }
             pd = pd<<1;
             ppd = ppd<<1;
@@ -750,9 +746,9 @@ jbig2_decode_generic_template2(Jbig2Ctx
             for (x_minor = 0; x_minor < minor_width; x_minor++) {
                 int bit;
 
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template2 optimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template2 optimized");
                 result |= bit << (7 - x_minor);
                 CONTEXT = ((CONTEXT & 0x1bd) << 1) | bit | ((line_m1 >> (10 - x_minor)) & 0x4) | ((line_m2 >> (10 - x_minor)) & 0x80);
             }
@@ -809,9 +805,9 @@ jbig2_decode_generic_template3(Jbig2Ctx
             for (x_minor = 0; x_minor < minor_width; x_minor++) {
                 int bit;
 
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template3 optimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template3 optimized");
                 result |= bit << (7 - x_minor);
                 CONTEXT = ((CONTEXT & 0x1f7) << 1) | bit | ((line_m1 >> (8 - x_minor)) & 0x10);
             }
@@ -860,9 +856,9 @@ jbig2_decode_generic_template3_unopt(Jbi
                 CONTEXT  = out_byte & 0x00F; /* First 4 pixels */
                 CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 4;
                 CONTEXT |= (pd>>9) & 0x3E0; /* Next 5 pixels */
-                bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template3 unoptimized");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template3 unoptimized");
             }
             pd = pd<<1;
             out_byte = (out_byte<<1) | bit;
@@ -925,9 +921,9 @@ jbig2_decode_generic_template0_TPGDON(Jb
         params->gbat[6] == -2 && params->gbat[7] == -2)
     {
         for (y = 0; y < GBH; y++) {
-            int bit = jbig2_arith_decode(as, &GB_stats[0x9B25]);
+            int bit = jbig2_arith_decode(ctx, as, &GB_stats[0x9B25]);
             if (bit < 0)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON1");
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON1");
             LTP ^= bit;
             if (!LTP) {
                 uint32_t out_byte = 0;
@@ -954,9 +950,9 @@ jbig2_decode_generic_template0_TPGDON(Jb
                         CONTEXT  = out_byte & 0x00F; /* First 4 pixels */
                         CONTEXT |= (pd>>8) & 0x7F0; /* Next 7 pixels */
                         CONTEXT |= (ppd>>2) & 0xF800; /* Final 5 pixels */
-                        bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                        bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                         if (bit < 0)
-                            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON2");
+                            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON2");
                     }
                     pd = pd<<1;
                     ppd = ppd<<1;
@@ -1023,9 +1019,9 @@ jbig2_decode_generic_template0_TPGDON(Jb
     /* So 0 <= y < top needs bounds checking. */
 
     for (y = 0; y < GBH; y++) {
-        int bit = jbig2_arith_decode(as, &GB_stats[0x9B25]);
+        int bit = jbig2_arith_decode(ctx, as, &GB_stats[0x9B25]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON1");
         LTP ^= bit;
         if (!LTP) {
             uint32_t out_byte = 0;
@@ -1066,9 +1062,9 @@ jbig2_decode_generic_template0_TPGDON(Jb
                         CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[4], y + params->gbat[5]) << 11;
                         CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[6], y + params->gbat[7]) << 15;
                     }
-                    bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                    bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON2");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template0 TPGDON2");
                 }
                 pd = pd<<1;
                 ppd = ppd<<1;
@@ -1111,9 +1107,9 @@ jbig2_decode_generic_template1_TPGDON(Jb
                            "adaptive template pixel is out of field");
 
     for (y = 0; y < GBH; y++) {
-        int bit = jbig2_arith_decode(as, &GB_stats[0x0795]);
+        int bit = jbig2_arith_decode(ctx, as, &GB_stats[0x0795]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template1 TPGDON1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template1 TPGDON1");
         LTP ^= bit;
         if (!LTP) {
             uint32_t out_byte = 0;
@@ -1141,9 +1137,9 @@ jbig2_decode_generic_template1_TPGDON(Jb
                     CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 3;
                     CONTEXT |= (pd>>9) & 0x01F0; /* next 5 pixels */
                     CONTEXT |= (ppd>>4) & 0x1E00; /* next 4 pixels */
-                    bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                    bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template1 TPGDON2");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template1 TPGDON2");
                 }
                 pd = pd<<1;
                 ppd = ppd<<1;
@@ -1186,9 +1182,9 @@ jbig2_decode_generic_template2_TPGDON(Jb
                            "adaptive template pixel is out of field");
 
     for (y = 0; y < GBH; y++) {
-        int bit = jbig2_arith_decode(as, &GB_stats[0xE5]);
+        int bit = jbig2_arith_decode(ctx, as, &GB_stats[0xE5]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template2 TPGDON1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template2 TPGDON1");
         LTP ^= bit;
         if (!LTP) {
             uint32_t out_byte = 0;
@@ -1216,9 +1212,9 @@ jbig2_decode_generic_template2_TPGDON(Jb
                     CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 2;
                     CONTEXT |= (pd>>11) & 0x078; /* next 4 pixels */
                     CONTEXT |= (ppd>>7) & 0x380; /* next 3 pixels */
-                    bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                    bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template2 TPGDON2");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template2 TPGDON2");
                 }
                 pd = pd<<1;
                 ppd = ppd<<1;
@@ -1261,9 +1257,9 @@ jbig2_decode_generic_template3_TPGDON(Jb
                            "adaptive template pixel is out of field");
 
     for (y = 0; y < GBH; y++) {
-        int bit = jbig2_arith_decode(as, &GB_stats[0x0195]);
+        int bit = jbig2_arith_decode(ctx, as, &GB_stats[0x0195]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template3 TPGDON1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template3 TPGDON1");
         LTP ^= bit;
         if (!LTP) {
             uint32_t out_byte = 0;
@@ -1283,9 +1279,9 @@ jbig2_decode_generic_template3_TPGDON(Jb
                     CONTEXT  = out_byte & 0x0F; /* First 4 pixels */
                     CONTEXT |= jbig2_image_get_pixel(image, x + params->gbat[0], y + params->gbat[1]) << 4;
                     CONTEXT |= (pd>>9) & 0x3E0; /* next 5 pixels */
-                    bit = jbig2_arith_decode(as, &GB_stats[CONTEXT]);
+                    bit = jbig2_arith_decode(ctx, as, &GB_stats[CONTEXT]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling generic template3 TPGDON2");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling generic template3 TPGDON2");
                 }
                 pd = pd<<1;
                 out_byte = (out_byte<<1) | bit;
@@ -1350,11 +1346,6 @@ jbig2_decode_generic_region(Jbig2Ctx *ct
 {
     const int8_t *gbat = params->gbat;
 
-    if (image->stride * image->height > (1 << 26) && segment->data_length < image->stride * image->height / (1 << 16)) {
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number,
-                           "region is far larger than data provided (%li << %d), aborting to prevent DOS", (long) segment->data_length, image->stride * image->height);
-    }
-
     if (!params->MMR && params->TPGDON)
         return jbig2_decode_generic_region_TPGDON(ctx, segment, params, as, image, GB_stats);
 
diff -pruN 0.18-1/jbig2_generic.h 0.18+20200417-1/jbig2_generic.h
--- 0.18-1/jbig2_generic.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_generic.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2.h 0.18+20200417-1/jbig2.h
--- 0.18-1/jbig2.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -65,7 +65,8 @@ struct _Jbig2Image {
    handler is used which prints fatal errors to the stderr stream. */
 
 /* error callback */
-typedef void (*Jbig2ErrorCallback)(void *data, const char *msg, Jbig2Severity severity, int32_t seg_idx);
+#define JBIG2_UNKNOWN_SEGMENT_NUMBER ~0U
+typedef void (*Jbig2ErrorCallback)(void *data, const char *msg, Jbig2Severity severity, uint32_t seg_idx);
 
 /* memory allocation is likewise done via a set of callbacks so that
    clients can better control memory usage. If a NULL is passed for
diff -pruN 0.18-1/jbig2_halftone.c 0.18+20200417-1/jbig2_halftone.c
--- 0.18-1/jbig2_halftone.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_halftone.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -47,12 +47,11 @@ jbig2_hd_new(Jbig2Ctx *ctx, const Jbig2P
     const uint32_t HPW = params->HDPW;
     const uint32_t HPH = params->HDPH;
     int code;
-    uint32_t i;
-    int j;
+    uint32_t i, j;
 
     if (N == 0) {
         /* We've wrapped. */
-        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "params->GRAYMAX out of range");
+        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "params->GRAYMAX out of range");
         return NULL;
     }
 
@@ -61,7 +60,7 @@ jbig2_hd_new(Jbig2Ctx *ctx, const Jbig2P
     if (new != NULL) {
         new->patterns = jbig2_new(ctx, Jbig2Image *, N);
         if (new->patterns == NULL) {
-            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate pattern in collective bitmap dictionary");
+            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate pattern in collective bitmap dictionary");
             jbig2_free(ctx->allocator, new);
             return NULL;
         }
@@ -73,7 +72,7 @@ jbig2_hd_new(Jbig2Ctx *ctx, const Jbig2P
         for (i = 0; i < N; i++) {
             new->patterns[i] = jbig2_image_new(ctx, HPW, HPH);
             if (new->patterns[i] == NULL) {
-                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to allocate pattern element image");
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate pattern element image");
                 for (j = 0; j < i; j++)
                     jbig2_free(ctx->allocator, new->patterns[j]);
                 jbig2_free(ctx->allocator, new);
@@ -84,7 +83,7 @@ jbig2_hd_new(Jbig2Ctx *ctx, const Jbig2P
                proper sub image */
             code = jbig2_image_compose(ctx, new->patterns[i], image, -i * (int32_t) HPW, 0, JBIG2_COMPOSE_REPLACE);
             if (code < 0) {
-                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to compose image into collective bitmap dictionary");
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to compose image into collective bitmap dictionary");
                 for (j = 0; j < i; j++)
                     jbig2_free(ctx->allocator, new->patterns[j]);
                 jbig2_free(ctx->allocator, new);
@@ -92,7 +91,7 @@ jbig2_hd_new(Jbig2Ctx *ctx, const Jbig2P
             }
         }
     } else {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate collective bitmap dictionary");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate collective bitmap dictionary");
     }
 
     return new;
@@ -464,8 +463,7 @@ jbig2_decode_halftone_region(Jbig2Ctx *c
     Jbig2Image *HSKIP = NULL;
     Jbig2PatternDict *HPATS;
     uint32_t i;
-    int32_t mg, ng;
-    int32_t x, y;
+    uint32_t mg, ng;
     uint16_t gray_val;
     int code = 0;
 
@@ -487,10 +485,10 @@ jbig2_decode_halftone_region(Jbig2Ctx *c
 
         for (mg = 0; mg < params->HGH; ++mg) {
             for (ng = 0; ng < params->HGW; ++ng) {
-                x = (params->HGX + mg * params->HRY + ng * params->HRX) >> 8;
-                y = (params->HGY + mg * params->HRX - ng * params->HRY) >> 8;
+                int64_t x = ((int64_t) params->HGX + mg * params->HRY + ng * params->HRX) >> 8;
+                int64_t y = ((int64_t) params->HGY + mg * params->HRX - ng * params->HRY) >> 8;
 
-                if (x + HPATS->HPW <= 0 || x >= (int32_t) image->width || y + HPATS->HPH <= 0 || y >= (int32_t) image->height) {
+                if (x + HPATS->HPW <= 0 || x >= image->width || y + HPATS->HPH <= 0 || y >= image->height) {
                     jbig2_image_set_pixel(HSKIP, ng, mg, 1);
                 } else {
                     jbig2_image_set_pixel(HSKIP, ng, mg, 0);
@@ -519,8 +517,8 @@ jbig2_decode_halftone_region(Jbig2Ctx *c
     /* 6.6.5 point 5. place patterns with procedure mentioned in 6.6.5.2 */
     for (mg = 0; mg < params->HGH; ++mg) {
         for (ng = 0; ng < params->HGW; ++ng) {
-            x = (params->HGX + mg * (int32_t) params->HRY + ng * (int32_t) params->HRX) >> 8;
-            y = (params->HGY + mg * (int32_t) params->HRX - ng * (int32_t) params->HRY) >> 8;
+            int64_t x = ((int64_t) params->HGX + mg * params->HRY + ng * params->HRX) >> 8;
+            int64_t y = ((int64_t) params->HGY + mg * params->HRX - ng * params->HRY) >> 8;
 
             /* prevent pattern index >= HNUMPATS */
             gray_val = GI[ng][mg];
diff -pruN 0.18-1/jbig2_halftone.h 0.18+20200417-1/jbig2_halftone.h
--- 0.18-1/jbig2_halftone.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_halftone.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -23,7 +23,7 @@
 typedef struct {
     int n_patterns;
     Jbig2Image **patterns;
-    int HPW, HPH;
+    uint32_t HPW, HPH;
 } Jbig2PatternDict;
 
 /* Table 24 */
diff -pruN 0.18-1/jbig2_huffman.c 0.18+20200417-1/jbig2_huffman.c
--- 0.18-1/jbig2_huffman.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_huffman.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -58,7 +58,7 @@ struct _Jbig2HuffmanState {
 };
 
 #define huff_get_next_word(hs, offset, word) \
-    (hs)->ws->get_next_word((hs)->ws, (offset), (word))
+    (hs)->ws->get_next_word((hs)->ctx, (hs)->ws, (offset), (word))
 
 /** Allocate and initialize a new huffman coding state
  *  the returned pointer can simply be freed; this does
@@ -80,18 +80,18 @@ jbig2_huffman_new(Jbig2Ctx *ctx, Jbig2Wo
         result->ctx = ctx;
         code = huff_get_next_word(result, 0, &result->this_word);
         if (code < 0) {
-            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed read first huffman word");
+            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read first huffman word");
             jbig2_huffman_free(ctx, result);
             return NULL;
         }
         code = huff_get_next_word(result, 4, &result->next_word);
         if (code < 0) {
-            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed read second huffman word");
+            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read second huffman word");
             jbig2_huffman_free(ctx, result);
             return NULL;
         }
     } else {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate new huffman coding state");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate new huffman coding state");
         return NULL;
     }
 
@@ -178,7 +178,7 @@ jbig2_dump_huffman_table(const Jbig2Huff
 int
 jbig2_huffman_skip(Jbig2HuffmanState *hs)
 {
-    int bits = hs->offset_bits & 7;
+    uint32_t bits = hs->offset_bits & 7;
     int code;
 
     if (bits) {
@@ -192,7 +192,7 @@ jbig2_huffman_skip(Jbig2HuffmanState *hs
         hs->offset += 4;
         code = huff_get_next_word(hs, hs->offset + 4, &hs->next_word);
         if (code < 0) {
-            return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to read next huffman word when skipping");
+            return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to read next huffman word when skipping");
         }
         hs->offset_bits -= 32;
         if (hs->offset_bits) {
@@ -216,11 +216,11 @@ jbig2_huffman_advance(Jbig2HuffmanState
     }
     code = huff_get_next_word(hs, hs->offset, &hs->this_word);
     if (code < 0) {
-        return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to get first huffman word after advancing");
+        return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to get first huffman word after advancing");
     }
     code = huff_get_next_word(hs, hs->offset + 4, &hs->next_word);
     if (code < 0) {
-        return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to get second huffman word after advancing");
+        return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to get second huffman word after advancing");
     }
     if (hs->offset_bits > 0)
         hs->this_word = (hs->this_word << hs->offset_bits) | (hs->next_word >> (32 - hs->offset_bits));
@@ -248,7 +248,7 @@ jbig2_huffman_get_bits(Jbig2HuffmanState
 
     if (hs->offset_limit && hs->offset >= hs->offset_limit) {
         *err = -1;
-        return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, -1, "end of jbig2 buffer reached at offset %d", hs->offset);
+        return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "end of jbig2 buffer reached at offset %d", hs->offset);
     }
 
     result = this_word >> (32 - bits);
@@ -259,7 +259,7 @@ jbig2_huffman_get_bits(Jbig2HuffmanState
         hs->this_word = hs->next_word;
         code = huff_get_next_word(hs, hs->offset + 4, &hs->next_word);
         if (code < 0) {
-            return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to get next huffman word");
+            return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to get next huffman word");
         }
         if (hs->offset_bits) {
             hs->this_word = (hs->this_word << hs->offset_bits) | (hs->next_word >> (32 - hs->offset_bits));
@@ -287,7 +287,7 @@ jbig2_huffman_get(Jbig2HuffmanState *hs,
     if (hs->offset_limit && hs->offset >= hs->offset_limit) {
         if (oob)
             *oob = -1;
-        return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, -1, "end of Jbig2WordStream reached at offset %d", hs->offset);
+        return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "end of Jbig2WordStream reached at offset %d", hs->offset);
     }
 
     for (;;) {
@@ -302,7 +302,7 @@ jbig2_huffman_get(Jbig2HuffmanState *hs,
         if (flags == (byte) -1 || PREFLEN == (byte) -1) {
             if (oob)
                 *oob = -1;
-            return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, -1, "encountered unpopulated huffman table entry");
+            return jbig2_error(hs->ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "encountered unpopulated huffman table entry");
         }
 
         next_word = hs->next_word;
@@ -312,7 +312,7 @@ jbig2_huffman_get(Jbig2HuffmanState *hs,
             hs->offset += 4;
             code = huff_get_next_word(hs, hs->offset + 4, &next_word);
             if (code < 0) {
-                return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to get next huffman word");
+                return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to get next huffman word");
             }
             offset_bits -= 32;
             hs->next_word = next_word;
@@ -343,7 +343,7 @@ jbig2_huffman_get(Jbig2HuffmanState *hs,
             hs->offset += 4;
             code = huff_get_next_word(hs, hs->offset + 4, &next_word);
             if (code < 0) {
-                return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, -1, "failed to get next huffman word");
+                return jbig2_error(hs->ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to get next huffman word");
             }
             offset_bits -= 32;
             hs->next_word = next_word;
@@ -391,7 +391,7 @@ jbig2_build_huffman_table(Jbig2Ctx *ctx,
     LENCOUNT = jbig2_new(ctx, int, lencountcount);
 
     if (LENCOUNT == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate huffman histogram");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate huffman histogram");
         return NULL;
     }
     memset(LENCOUNT, 0, sizeof(int) * lencountcount);
@@ -414,19 +414,19 @@ jbig2_build_huffman_table(Jbig2Ctx *ctx,
         if (lts <= LOG_TABLE_SIZE_MAX && log_table_size < lts)
             log_table_size = lts;
     }
-    jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "constructing huffman table log size %d", log_table_size);
+    jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "constructing huffman table log size %d", log_table_size);
     max_j = 1 << log_table_size;
 
     result = jbig2_new(ctx, Jbig2HuffmanTable, 1);
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate result");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate result");
         jbig2_free(ctx->allocator, LENCOUNT);
         return NULL;
     }
     result->log_table_size = log_table_size;
     entries = jbig2_new(ctx, Jbig2HuffmanEntry, max_j);
     if (entries == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate result entries");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate result entries");
         jbig2_free(ctx->allocator, result);
         jbig2_free(ctx->allocator, LENCOUNT);
         return NULL;
@@ -455,7 +455,7 @@ jbig2_build_huffman_table(Jbig2Ctx *ctx,
                 byte eflags = 0;
 
                 if (end_j > max_j) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "ran off the end of the entries table! (%d >= %d)", end_j, max_j);
+                    jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ran off the end of the entries table! (%d >= %d)", end_j, max_j);
                     jbig2_free(ctx->allocator, result->entries);
                     jbig2_free(ctx->allocator, result);
                     jbig2_free(ctx->allocator, LENCOUNT);
@@ -718,7 +718,7 @@ static const byte test_stream[] = { 0xe9
 static const byte test_tabindex[] = { 4, 2, 2, 1 };
 
 static int
-test_get_word1(Jbig2WordStream *self, size_t offset, uint32_t *word)
+test_get_word1(Jbig2Ctx *ctx, Jbig2WordStream *self, size_t offset, uint32_t *word)
 {
     uint32_t val = 0;
     int ret = 0;
@@ -2029,7 +2029,7 @@ typedef struct test_stream {
 } test_stream_t;
 
 static int
-test_get_word2(Jbig2WordStream *self, size_t offset, uint32_t *word)
+test_get_word2(Jbig2Ctx *ctx, Jbig2WordStream *self, size_t offset, uint32_t *word)
 {
     test_stream_t *st = (test_stream_t *) self;
     uint32_t val = 0;
@@ -2072,13 +2072,13 @@ static int test2()
         return 0;
     }
 
-    for (i = 0; i < countof(tests); i++) {
+    for (i = 0; i < (int) countof(tests); i++) {
         Jbig2HuffmanTable *table;
         Jbig2HuffmanState *hs;
         test_stream_t st;
         int32_t code;
         bool oob;
-        int j;
+        size_t j;
 
         st.ws.get_next_word = test_get_word2;
         st.h = &tests[i];
diff -pruN 0.18-1/jbig2_huffman.h 0.18+20200417-1/jbig2_huffman.h
--- 0.18-1/jbig2_huffman.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_huffman.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_hufftab.c 0.18+20200417-1/jbig2_hufftab.c
--- 0.18-1/jbig2_hufftab.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_hufftab.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_hufftab.h 0.18+20200417-1/jbig2_hufftab.h
--- 0.18-1/jbig2_hufftab.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_hufftab.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_image.c 0.18+20200417-1/jbig2_image.c
--- 0.18-1/jbig2_image.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_image.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -30,13 +30,6 @@
 #include "jbig2_priv.h"
 #include "jbig2_image.h"
 
-#if !defined (INT32_MAX)
-#define INT32_MAX  0x7fffffff
-#endif
-#if !defined (UINT32_MAX)
-#define UINT32_MAX  0xffffffffu
-#endif
-
 /* allocate a Jbig2Image structure and its associated bitmap */
 Jbig2Image *
 jbig2_image_new(Jbig2Ctx *ctx, uint32_t width, uint32_t height)
@@ -45,13 +38,13 @@ jbig2_image_new(Jbig2Ctx *ctx, uint32_t
     uint32_t stride;
 
     if (width == 0 || height == 0) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to create zero sized image");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to create zero sized image");
         return NULL;
     }
 
     image = jbig2_new(ctx, Jbig2Image, 1);
     if (image == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate image");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate image");
         return NULL;
     }
 
@@ -59,13 +52,13 @@ jbig2_image_new(Jbig2Ctx *ctx, uint32_t
 
     /* check for integer multiplication overflow */
     if (height > (INT32_MAX / stride)) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "integer multiplication overflow (stride=%u, height=%u)", stride, height);
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "integer multiplication overflow (stride=%u, height=%u)", stride, height);
         jbig2_free(ctx->allocator, image);
         return NULL;
     }
     image->data = jbig2_new(ctx, uint8_t, (size_t) height * stride);
     if (image->data == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate image data buffer (stride=%u, height=%u)", stride, height);
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate image data buffer (stride=%u, height=%u)", stride, height);
         jbig2_free(ctx->allocator, image);
         return NULL;
     }
@@ -117,13 +110,13 @@ jbig2_image_resize(Jbig2Ctx *ctx, Jbig2I
 
         /* check for integer multiplication overflow */
         if (image->height > (INT32_MAX / image->stride)) {
-            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "integer multiplication overflow during resize (stride=%u, height=%u)", image->stride, height);
+            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "integer multiplication overflow during resize (stride=%u, height=%u)", image->stride, height);
             return NULL;
         }
         /* use the same stride, just change the length */
         data = jbig2_renew(ctx, image->data, uint8_t, (size_t) height * image->stride);
         if (data == NULL) {
-            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to reallocate image");
+            jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to reallocate image");
             return NULL;
         }
         image->data = data;
@@ -141,14 +134,14 @@ jbig2_image_resize(Jbig2Ctx *ctx, Jbig2I
 
         newimage = jbig2_image_new(ctx, width, height);
         if (newimage == NULL) {
-            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to allocate resized image");
+            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate resized image");
             return NULL;
         }
         jbig2_image_clear(ctx, newimage, value);
 
         code = jbig2_image_compose(ctx, newimage, image, 0, 0, JBIG2_COMPOSE_REPLACE);
         if (code < 0) {
-            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to compose image buffers when resizing");
+            jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to compose image buffers when resizing");
             jbig2_image_release(ctx, newimage);
             return NULL;
         }
@@ -358,7 +351,7 @@ jbig2_image_compose(Jbig2Ctx *ctx, Jbig2
         (UINT32_MAX - src->height < (y > 0 ? y : -y)))
     {
 #ifdef JBIG2_DEBUG
-        jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "overflow in compose_image");
+        jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "overflow in compose_image");
 #endif
         return 0;
     }
@@ -418,13 +411,13 @@ jbig2_image_compose(Jbig2Ctx *ctx, Jbig2
             h = dst->height - y;
     }
 #ifdef JBIG2_DEBUG
-    jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "compositing %dx%d at (%d, %d) after clipping", w, h, x, y);
+    jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "compositing %dx%d at (%d, %d) after clipping", w, h, x, y);
 #endif
 
     /* check for zero clipping region */
     if ((w <= 0) || (h <= 0)) {
 #ifdef JBIG2_DEBUG
-        jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "zero clipping region");
+        jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "zero clipping region");
 #endif
         return 0;
     }
diff -pruN 0.18-1/jbig2_image.h 0.18+20200417-1/jbig2_image.h
--- 0.18-1/jbig2_image.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_image.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_image_pbm.c 0.18+20200417-1/jbig2_image_pbm.c
--- 0.18-1/jbig2_image_pbm.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_image_pbm.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_image_png.c 0.18+20200417-1/jbig2_image_png.c
--- 0.18-1/jbig2_image_png.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_image_png.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_image_rw.h 0.18+20200417-1/jbig2_image_rw.h
--- 0.18-1/jbig2_image_rw.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_image_rw.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_mmr.c 0.18+20200417-1/jbig2_mmr.c
--- 0.18-1/jbig2_mmr.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_mmr.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -40,15 +40,12 @@
 #include "jbig2_mmr.h"
 #include "jbig2_segment.h"
 
-#if !defined (UINT32_MAX)
-#define UINT32_MAX 0xffffffff
-#endif
-
 typedef struct {
     uint32_t width;
     uint32_t height;
     const byte *data;
     size_t size;
+    size_t consumed_bits;
     uint32_t data_index;
     uint32_t bit_index;
     uint32_t word;
@@ -62,30 +59,34 @@ typedef struct {
 static void
 jbig2_decode_mmr_init(Jbig2MmrCtx *mmr, int width, int height, const byte *data, size_t size)
 {
-    size_t i;
-    uint32_t word = 0;
-
     mmr->width = width;
     mmr->height = height;
     mmr->data = data;
     mmr->size = size;
     mmr->data_index = 0;
-    mmr->bit_index = 0;
+    mmr->bit_index = 32;
+    mmr->word = 0;
+    mmr->consumed_bits = 0;
 
-    for (i = 0; i < size && i < 4; i++)
-        word |= (data[i] << ((3 - i) << 3));
-    mmr->word = word;
+    while (mmr->bit_index >= 8 && mmr->data_index < mmr->size) {
+        mmr->bit_index -= 8;
+        mmr->word |= (mmr->data[mmr->data_index] << mmr->bit_index);
+        mmr->data_index++;
+    }
 }
 
 static void
 jbig2_decode_mmr_consume(Jbig2MmrCtx *mmr, int n_bits)
 {
+    mmr->consumed_bits += n_bits;
+    if (mmr->consumed_bits > mmr->size * 8)
+        mmr->consumed_bits = mmr->size * 8;
+
     mmr->word <<= n_bits;
     mmr->bit_index += n_bits;
-    while (mmr->bit_index >= 8) {
+    while (mmr->bit_index >= 8 && mmr->data_index < mmr->size) {
         mmr->bit_index -= 8;
-        if (mmr->data_index + 4 < mmr->size)
-            mmr->word |= (mmr->data[mmr->data_index + 4] << mmr->bit_index);
+        mmr->word |= (mmr->data[mmr->data_index] << mmr->bit_index);
         mmr->data_index++;
     }
 }
@@ -955,11 +956,11 @@ jbig2_decode_get_run(Jbig2Ctx *ctx, Jbig
     do {
         val = jbig2_decode_get_code(mmr, table, initial_bits);
         if (val == ERROR)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "invalid code detected in MMR-coded data");
+            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "invalid code detected in MMR-coded data");
         else if (val == UNCOMPRESSED)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "uncompressed code in MMR-coded data");
+            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "uncompressed code in MMR-coded data");
         else if (val == ZEROES)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "zeroes code in MMR-coded data");
+            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "zeroes code in MMR-coded data");
         result += val;
     } while (val >= 64);
 
@@ -992,10 +993,10 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
             if (c == 0) {
                 white_run = jbig2_decode_get_run(ctx, mmr, jbig2_mmr_white_decode, 8);
                 if (white_run < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to decode white H run");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode white H run");
                 black_run = jbig2_decode_get_run(ctx, mmr, jbig2_mmr_black_decode, 7);
                 if (black_run < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to decode black H run");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode black H run");
                 /* printf ("H %d %d\n", white_run, black_run); */
                 a1 = a0 + white_run;
                 a2 = a1 + black_run;
@@ -1004,7 +1005,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 if (a2 > mmr->width)
                     a2 = mmr->width;
                 if (a2 < a1) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative black H run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative black H run");
                     a2 = a1;
                 }
                 if (a1 < mmr->width)
@@ -1013,10 +1014,10 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
             } else {
                 black_run = jbig2_decode_get_run(ctx, mmr, jbig2_mmr_black_decode, 7);
                 if (black_run < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to decode black H run");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode black H run");
                 white_run = jbig2_decode_get_run(ctx, mmr, jbig2_mmr_white_decode, 8);
                 if (white_run < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to decode white H run");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode white H run");
                 /* printf ("H %d %d\n", black_run, white_run); */
                 a1 = a0 + black_run;
                 a2 = a1 + white_run;
@@ -1025,7 +1026,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 if (a2 > mmr->width)
                     a2 = mmr->width;
                 if (a1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative white H run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative white H run");
                     a1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1041,7 +1042,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
             b2 = jbig2_find_changing_element(ref, b1, mmr->width);
             if (c) {
                 if (b2 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative P run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative P run");
                     b2 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1056,7 +1057,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
             b1 = jbig2_find_changing_element_of_color(ref, a0, mmr->width, !c);
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative V(0) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative V(0) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1074,7 +1075,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 += 1;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VR(1) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VR(1) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1092,7 +1093,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 += 2;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VR(2) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VR(2) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1110,7 +1111,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 += 3;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VR(3) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VR(3) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1128,7 +1129,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 -= 1;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VL(1) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VL(1) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1146,7 +1147,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 -= 2;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VL(2) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VL(2) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1164,7 +1165,7 @@ jbig2_decode_mmr_line(Jbig2Ctx *ctx, Jbi
                 b1 -= 3;
             if (c) {
                 if (b1 < a0) {
-                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "ignoring negative VL(3) run");
+                    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "ignoring negative VL(3) run");
                     b1 = a0;
                 }
                 if (a0 < mmr->width)
@@ -1249,7 +1250,7 @@ jbig2_decode_halftone_mmr(Jbig2Ctx *ctx,
         memset(dst, 0, rowstride);
         code = jbig2_decode_mmr_line(ctx, &mmr, ref, dst, &eofb);
         if (code < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to decode halftone mmr line");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode halftone mmr line");
         ref = dst;
         dst += rowstride;
     }
@@ -1263,6 +1264,6 @@ jbig2_decode_halftone_mmr(Jbig2Ctx *ctx,
         jbig2_decode_mmr_consume(&mmr, 24);
     }
 
-    *consumed_bytes += mmr.data_index + (mmr.bit_index >> 3) + (mmr.bit_index > 0 ? 1 : 0);
+    *consumed_bytes += (mmr.consumed_bits + 7) / 8;
     return code;
 }
diff -pruN 0.18-1/jbig2_mmr.h 0.18+20200417-1/jbig2_mmr.h
--- 0.18-1/jbig2_mmr.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_mmr.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_page.c 0.18+20200417-1/jbig2_page.c
--- 0.18-1/jbig2_page.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_page.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -34,13 +34,6 @@
 #include "jbig2_page.h"
 #include "jbig2_segment.h"
 
-#if !defined (INT32_MAX)
-#define INT32_MAX  0x7fffffff
-#endif
-#if !defined (UINT32_MAX)
-#define UINT32_MAX 0xffffffff
-#endif
-
 /* dump the page struct info */
 static void
 dump_page_info(Jbig2Ctx *ctx, Jbig2Segment *segment, Jbig2Page *page)
@@ -79,13 +72,21 @@ jbig2_page_info(Jbig2Ctx *ctx, Jbig2Segm
 
     /* find a free page */
     {
-        int index, j;
+        size_t index, j;
 
         index = ctx->current_page;
         while (ctx->pages[index].state != JBIG2_PAGE_FREE) {
             index++;
             if (index >= ctx->max_page_index) {
                 /* grow the list */
+
+                if (ctx->max_page_index == UINT32_MAX) {
+                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "too many pages in jbig2 image");
+                }
+                else if (ctx->max_page_index > (UINT32_MAX >> 2)) {
+                    ctx->max_page_index = UINT32_MAX;
+                }
+
                 pages = jbig2_renew(ctx, ctx->pages, Jbig2Page, (ctx->max_page_index <<= 2));
                 if (pages == NULL) {
                     return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to reallocate pages");
@@ -222,7 +223,7 @@ jbig2_complete_page(Jbig2Ctx *ctx)
 
     /* ensure image exists before marking page as complete */
     if (ctx->pages[ctx->current_page].image == NULL) {
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "page has no image, cannot be completed");
+        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "page has no image, cannot be completed");
     }
 
     ctx->pages[ctx->current_page].state = JBIG2_PAGE_COMPLETE;
@@ -270,27 +271,27 @@ jbig2_page_add_result(Jbig2Ctx *ctx, Jbi
     int code;
 
     if (x > INT32_MAX || y > INT32_MAX)
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "unsupported image coordinates");
+        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unsupported image coordinates");
 
     /* ensure image exists first */
     if (page->image == NULL)
-        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "page info possibly missing, no image defined");
+        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "page info possibly missing, no image defined");
 
     /* grow the page to accommodate a new stripe if necessary */
     if (page->striped && page->height == 0xFFFFFFFF) {
         uint32_t new_height;
 
         if (y > UINT32_MAX - image->height)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "adding image at coordinate would grow page out of bounds");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "adding image at coordinate would grow page out of bounds");
         new_height = y + image->height;
 
         if (page->image->height < new_height) {
             Jbig2Image *resized_image = NULL;
 
-            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "growing page buffer to %u rows to accommodate new stripe", new_height);
+            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "growing page buffer to %u rows to accommodate new stripe", new_height);
             resized_image = jbig2_image_resize(ctx, page->image, page->image->width, new_height, page->flags & 4);
             if (resized_image == NULL) {
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "unable to resize image to accommodate new stripe");
+                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "unable to resize image to accommodate new stripe");
             }
             page->image = resized_image;
         }
@@ -298,7 +299,7 @@ jbig2_page_add_result(Jbig2Ctx *ctx, Jbi
 
     code = jbig2_image_compose(ctx, page->image, image, x, y, op);
     if (code < 0)
-        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to compose image with page");
+        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to compose image with page");
 
     return 0;
 }
@@ -318,7 +319,7 @@ jbig2_page_add_result(Jbig2Ctx *ctx, Jbi
 Jbig2Image *
 jbig2_page_out(Jbig2Ctx *ctx)
 {
-    int index;
+    uint32_t index;
 
     /* search for a completed page */
     for (index = 0; index < ctx->max_page_index; index++) {
@@ -327,12 +328,12 @@ jbig2_page_out(Jbig2Ctx *ctx)
             uint32_t page_number = ctx->pages[index].number;
 
             if (img == NULL) {
-                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "page %d returned with no associated image", page_number);
+                jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "page %d returned with no associated image", page_number);
                 continue;
             }
 
             ctx->pages[index].state = JBIG2_PAGE_RETURNED;
-            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "page %d returned to the client", page_number);
+            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "page %d returned to the client", page_number);
             return jbig2_image_reference(ctx, img);
         }
     }
@@ -347,7 +348,7 @@ jbig2_page_out(Jbig2Ctx *ctx)
 void
 jbig2_release_page(Jbig2Ctx *ctx, Jbig2Image *image)
 {
-    int index;
+    uint32_t index;
 
     if (image == NULL)
         return;
@@ -357,11 +358,11 @@ jbig2_release_page(Jbig2Ctx *ctx, Jbig2I
         if (ctx->pages[index].image == image) {
             jbig2_image_release(ctx, image);
             ctx->pages[index].state = JBIG2_PAGE_RELEASED;
-            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, -1, "page %d released by the client", ctx->pages[index].number);
+            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, JBIG2_UNKNOWN_SEGMENT_NUMBER, "page %d released by the client", ctx->pages[index].number);
             return;
         }
     }
 
     /* no matching pages */
-    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to release unknown page");
+    jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to release unknown page");
 }
diff -pruN 0.18-1/jbig2_page.h 0.18+20200417-1/jbig2_page.h
--- 0.18-1/jbig2_page.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_page.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_priv.h 0.18+20200417-1/jbig2_priv.h
--- 0.18-1/jbig2_priv.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_priv.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -55,6 +55,16 @@ typedef uint8_t byte;
 #define NULL ((void*)0)
 #endif
 
+#if !defined (INT32_MIN)
+#define INT32_MIN (-0x7fffffff - 1)
+#endif
+#if !defined (INT32_MAX)
+#define INT32_MAX  0x7fffffff
+#endif
+#if !defined (UINT32_MAX)
+#define UINT32_MAX 0xffffffffu
+#endif
+
 typedef struct _Jbig2Page Jbig2Page;
 typedef struct _Jbig2Segment Jbig2Segment;
 
@@ -76,23 +86,23 @@ struct _Jbig2Ctx {
 
     byte *buf;
     size_t buf_size;
-    unsigned int buf_rd_ix;
-    unsigned int buf_wr_ix;
+    size_t buf_rd_ix;
+    size_t buf_wr_ix;
 
     Jbig2FileState state;
 
     uint8_t file_header_flags;
     uint32_t n_pages;
 
-    int n_segments_max;
+    uint32_t n_segments_max;
     Jbig2Segment **segments;
-    int n_segments;             /* index of last segment header parsed */
-    int segment_index;          /* index of last segment body parsed */
+    uint32_t n_segments;             /* index of last segment header parsed */
+    uint32_t segment_index;          /* index of last segment body parsed */
 
     /* list of decoded pages, including the one in progress,
        currently stored as a contiguous, 0-indexed array. */
-    int current_page;
-    int max_page_index;
+    uint32_t current_page;
+    uint32_t max_page_index;
     Jbig2Page *pages;
 };
 
@@ -115,7 +125,7 @@ void *jbig2_realloc(Jbig2Allocator *allo
 
 #define jbig2_renew(ctx, p, t, size) ((t *)jbig2_realloc(ctx->allocator, (p), size, sizeof(t)))
 
-int jbig2_error(Jbig2Ctx *ctx, Jbig2Severity severity, int32_t seg_idx, const char *fmt, ...)
+int jbig2_error(Jbig2Ctx *ctx, Jbig2Severity severity, uint32_t seg_idx, const char *fmt, ...)
 #ifdef __GNUC__
     __attribute__ ((format (__printf__, 4, 5)))
 #endif
@@ -129,7 +139,7 @@ int jbig2_error(Jbig2Ctx *ctx, Jbig2Seve
 typedef struct _Jbig2WordStream Jbig2WordStream;
 
 struct _Jbig2WordStream {
-    int (*get_next_word)(Jbig2WordStream *self, size_t offset, uint32_t *word);
+    int (*get_next_word)(Jbig2Ctx *ctx, Jbig2WordStream *self, size_t offset, uint32_t *word);
 };
 
 Jbig2WordStream *jbig2_word_stream_buf_new(Jbig2Ctx *ctx, const byte *data, size_t size);
diff -pruN 0.18-1/jbig2_refinement.c 0.18+20200417-1/jbig2_refinement.c
--- 0.18-1/jbig2_refinement.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_refinement.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -80,9 +80,9 @@ jbig2_decode_refinement_template0_unopt(
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx + 1, y - dy - 1) << 10;
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx + 0, y - dy - 1) << 11;
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx + params->grat[2], y - dy + params->grat[3]) << 12;
-            bit = jbig2_arith_decode(as, &GR_stats[CONTEXT]);
+            bit = jbig2_arith_decode(ctx, as, &GR_stats[CONTEXT]);
             if (bit < 0)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling refinement template0");
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling refinement template0");
             jbig2_image_set_pixel(image, x, y, bit);
         }
     }
@@ -134,9 +134,9 @@ jbig2_decode_refinement_template1_unopt(
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx + 0, y - dy + 0) << 7;
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx - 1, y - dy + 0) << 8;
             CONTEXT |= jbig2_image_get_pixel(ref, x - dx + 0, y - dy - 1) << 9;
-            bit = jbig2_arith_decode(as, &GR_stats[CONTEXT]);
+            bit = jbig2_arith_decode(ctx, as, &GR_stats[CONTEXT]);
             if (bit < 0)
-                return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling refinement template0");
+                return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling refinement template0");
             jbig2_image_set_pixel(image, x, y, bit);
         }
     }
@@ -211,9 +211,9 @@ jbig2_decode_refinement_template1(Jbig2C
             for (x_minor = 0; x_minor < minor_width; x_minor++) {
                 int bit;
 
-                bit = jbig2_arith_decode(as, &GR_stats[CONTEXT]);
+                bit = jbig2_arith_decode(ctx, as, &GR_stats[CONTEXT]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "failed to decode arithmetic code when handling refinement template1");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to decode arithmetic code when handling refinement template1");
                 result |= bit << (7 - x_minor);
                 CONTEXT = ((CONTEXT & 0x0d6) << 1) | bit |
                           ((line_m1 >> (9 - x_minor)) & 0x002) |
@@ -312,28 +312,28 @@ jbig2_decode_refinement_TPGRON(Jbig2Ctx
     if (params->GRTEMPLATE == 0 &&
         (pixel_outside_field(params->grat[0], params->grat[1]) ||
         refpixel_outside_field(params->grat[2], params->grat[3])))
-        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1,
+        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER,
                            "adaptive template pixel is out of field");
 
     for (y = 0; y < GRH; y++) {
-        int bit = jbig2_arith_decode(as, &GR_stats[start_context]);
+        int bit = jbig2_arith_decode(ctx, as, &GR_stats[start_context]);
         if (bit < 0)
-            return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode arithmetic code when handling refinement TPGRON1");
+            return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode arithmetic code when handling refinement TPGRON1");
         LTP ^= bit;
         if (!LTP) {
             for (x = 0; x < GRW; x++) {
-                bit = jbig2_arith_decode(as, &GR_stats[mkctx(params, image, x, y)]);
+                bit = jbig2_arith_decode(ctx, as, &GR_stats[mkctx(params, image, x, y)]);
                 if (bit < 0)
-                    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode arithmetic code when handling refinement TPGRON1");
+                    return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode arithmetic code when handling refinement TPGRON1");
                 jbig2_image_set_pixel(image, x, y, bit);
             }
         } else {
             for (x = 0; x < GRW; x++) {
                 iv = implicit_value(params, image, x, y);
                 if (iv < 0) {
-                    int bit = jbig2_arith_decode(as, &GR_stats[mkctx(params, image, x, y)]);
+                    int bit = jbig2_arith_decode(ctx, as, &GR_stats[mkctx(params, image, x, y)]);
                     if (bit < 0)
-                        return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to decode arithmetic code when handling refinement TPGRON1");
+                        return jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to decode arithmetic code when handling refinement TPGRON1");
                     jbig2_image_set_pixel(image, x, y, bit);
                 } else
                     jbig2_image_set_pixel(image, x, y, iv);
diff -pruN 0.18-1/jbig2_refinement.h 0.18+20200417-1/jbig2_refinement.h
--- 0.18-1/jbig2_refinement.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_refinement.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_segment.c 0.18+20200417-1/jbig2_segment.c
--- 0.18-1/jbig2_segment.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_segment.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -39,10 +39,6 @@
 #include "jbig2_symbol_dict.h"
 #include "jbig2_text.h"
 
-#if !defined (UINT32_MAX)
-#define UINT32_MAX 0xffffffff
-#endif
-
 Jbig2Segment *
 jbig2_parse_segment_header(Jbig2Ctx *ctx, uint8_t *buf, size_t buf_size, size_t *p_header_size)
 {
@@ -61,12 +57,17 @@ jbig2_parse_segment_header(Jbig2Ctx *ctx
 
     result = jbig2_new(ctx, Jbig2Segment, 1);
     if (result == NULL) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate segment");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate segment");
         return NULL;
     }
 
     /* 7.2.2 */
     result->number = jbig2_get_uint32(buf);
+    if (result->number == JBIG2_UNKNOWN_SEGMENT_NUMBER) {
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "segment number too large");
+        jbig2_free(ctx->allocator, result);
+        return NULL;
+    }
 
     /* 7.2.3 */
     result->flags = buf[4];
@@ -87,7 +88,7 @@ jbig2_parse_segment_header(Jbig2Ctx *ctx
     referred_to_segment_size = result->number <= 256 ? 1 : result->number <= 65536 ? 2 : 4;     /* 7.2.5 */
     pa_size = result->flags & 0x40 ? 4 : 1;     /* 7.2.6 */
     if (offset + referred_to_segment_count * referred_to_segment_size + pa_size + 4 > buf_size) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, result->number, "insufficient data to parse segment header");
+        jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, result->number, "attempted to parse segment header with insufficient data, asking for more data");
         jbig2_free(ctx->allocator, result);
         return NULL;
     }
diff -pruN 0.18-1/jbig2_segment.h 0.18+20200417-1/jbig2_segment.h
--- 0.18-1/jbig2_segment.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_segment.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_symbol_dict.c 0.18+20200417-1/jbig2_symbol_dict.c
--- 0.18-1/jbig2_symbol_dict.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_symbol_dict.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -70,7 +70,7 @@ void
 jbig2_dump_symbol_dict(Jbig2Ctx *ctx, Jbig2Segment *segment)
 {
     Jbig2SymbolDict *dict = (Jbig2SymbolDict *) segment->result;
-    int index;
+    uint32_t index;
     char filename[24];
     int code;
 
@@ -102,14 +102,14 @@ jbig2_sd_new(Jbig2Ctx *ctx, uint32_t n_s
         new_dict->glyphs = jbig2_new(ctx, Jbig2Image *, n_symbols);
         new_dict->n_symbols = n_symbols;
     } else {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate new empty symbol dictionary");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate new empty symbol dictionary");
         return NULL;
     }
 
     if (new_dict->glyphs != NULL) {
         memset(new_dict->glyphs, 0, n_symbols * sizeof(Jbig2Image *));
     } else if (new_dict->n_symbols > 0) {
-        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, -1, "failed to allocate glyphs for new empty symbol dictionary");
+        jbig2_error(ctx, JBIG2_SEVERITY_FATAL, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate glyphs for new empty symbol dictionary");
         jbig2_free(ctx->allocator, new_dict);
         return NULL;
     }
@@ -215,7 +215,7 @@ jbig2_sd_cat(Jbig2Ctx *ctx, uint32_t n_d
             for (j = 0; j < dicts[i]->n_symbols; j++)
                 new_dict->glyphs[k++] = jbig2_image_reference(ctx, dicts[i]->glyphs[j]);
     } else {
-        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, -1, "failed to allocate new symbol dictionary");
+        jbig2_error(ctx, JBIG2_SEVERITY_WARNING, JBIG2_UNKNOWN_SEGMENT_NUMBER, "failed to allocate new symbol dictionary");
     }
 
     return new_dict;
@@ -236,7 +236,7 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
     uint32_t SYMWIDTH, TOTWIDTH;
     uint32_t HCFIRSTSYM;
     uint32_t *SDNEWSYMWIDTHS = NULL;
-    int SBSYMCODELEN = 0;
+    uint8_t SBSYMCODELEN = 0;
     Jbig2WordStream *ws = NULL;
     Jbig2HuffmanState *hs = NULL;
     Jbig2ArithState *as = NULL;
@@ -271,6 +271,8 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
         return NULL;
     }
 
+    for (SBSYMCODELEN = 0; ((uint64_t) 1 << SBSYMCODELEN) < ((uint64_t) params->SDNUMINSYMS + params->SDNUMNEWSYMS); SBSYMCODELEN++);
+
     if (params->SDHUFF) {
         jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, segment->number, "huffman coded symbol dictionary");
         hs = jbig2_huffman_new(ctx, ws);
@@ -282,6 +284,7 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
             jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to allocate for symbol bitmap");
             goto cleanup;
         }
+        /* 6.5.5 (2) */
         if (!params->SDREFAGG) {
             SDNEWSYMWIDTHS = jbig2_new(ctx, uint32_t, params->SDNUMNEWSYMS);
             if (SDNEWSYMWIDTHS == NULL) {
@@ -310,7 +313,6 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
             jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to allocate symbol bitmap");
             goto cleanup;
         }
-        for (SBSYMCODELEN = 0; ((uint64_t) 1 << SBSYMCODELEN) < ((uint64_t) params->SDNUMINSYMS + params->SDNUMNEWSYMS); SBSYMCODELEN++);
         tparams.IAID = jbig2_arith_iaid_ctx_new(ctx, SBSYMCODELEN);
         tparams.IARDX = jbig2_arith_int_ctx_new(ctx);
         tparams.IARDY = jbig2_arith_int_ctx_new(ctx);
@@ -347,6 +349,7 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
     tparams.SBDSOFFSET = 0;
     tparams.SBRTEMPLATE = params->SDRTEMPLATE;
 
+    /* 6.5.5 (1) */
     SDNEWSYMS = jbig2_sd_new(ctx, params->SDNUMNEWSYMS);
     if (SDNEWSYMS == NULL) {
         jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to allocate new symbols (%u)", params->SDNUMNEWSYMS);
@@ -426,14 +429,24 @@ jbig2_decode_symbol_dict(Jbig2Ctx *ctx,
                 break;
             }
 
+            if (DW < 0 && SYMWIDTH < (uint32_t) -DW) {
+                code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "DW value (%d) would make SYMWIDTH (%u) negative at symbol %u", DW, SYMWIDTH, NSYMSDECODED + 1);
+                goto cleanup;
+            }
+            if (DW > 0 && (uint32_t) DW > UINT32_MAX - SYMWIDTH) {
+                code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "DW value (%d) would make SYMWIDTH (%u) too large at symbol %u", DW, SYMWIDTH, NSYMSDECODED + 1);
+                goto cleanup;
+            }
+
             SYMWIDTH = SYMWIDTH + DW;
-            TOTWIDTH = TOTWIDTH + SYMWIDTH;
-            if ((int32_t) SYMWIDTH < 0) {
-                code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "invalid SYMWIDTH value (%d) at symbol %d", SYMWIDTH, NSYMSDECODED + 1);
+            if (SYMWIDTH > UINT32_MAX - TOTWIDTH) {
+                code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "SYMWIDTH value (%u) would make TOTWIDTH (%u) too large at symbol %u", SYMWIDTH, TOTWIDTH, NSYMSDECODED + 1);
                 goto cleanup;
             }
+
+            TOTWIDTH = TOTWIDTH + SYMWIDTH;
 #ifdef JBIG2_DEBUG
-            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, segment->number, "SYMWIDTH = %d TOTWIDTH = %d", SYMWIDTH, TOTWIDTH);
+            jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, segment->number, "SYMWIDTH = %u TOTWIDTH = %u", SYMWIDTH, TOTWIDTH);
 #endif
             /* 6.5.5 (4c.ii) */
             if (!params->SDHUFF || params->SDREFAGG) {
diff -pruN 0.18-1/jbig2_symbol_dict.h 0.18+20200417-1/jbig2_symbol_dict.h
--- 0.18-1/jbig2_symbol_dict.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_symbol_dict.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/jbig2_text.c 0.18+20200417-1/jbig2_text.c
--- 0.18-1/jbig2_text.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_text.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
@@ -593,9 +593,14 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
     uint32_t table_index = 0;
     const Jbig2HuffmanParams *huffman_params = NULL;
 
+    /* zero params to ease cleanup later */
+    memset(&params, 0, sizeof(Jbig2TextRegionParams));
+
     /* 7.4.1 */
-    if (segment->data_length < 17)
-        goto too_short;
+    if (segment->data_length < 17) {
+        code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+        goto cleanup2;
+    }
     jbig2_get_region_segment_info(&region_info, segment_data);
     offset += 17;
     /* Check for T.88 amendment 3 */
@@ -603,16 +608,15 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
         return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "region segment flags indicate use of colored bitmap (NYI)");
 
     /* 7.4.3.1.1 */
-    if (segment->data_length - offset < 2)
-        goto too_short;
+    if (segment->data_length - offset < 2) {
+        code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+        goto cleanup2;
+    }
     flags = jbig2_get_uint16(segment_data + offset);
     offset += 2;
 
     jbig2_error(ctx, JBIG2_SEVERITY_DEBUG, segment->number, "text region header flags 0x%04x", flags);
 
-    /* zero params to ease cleanup later */
-    memset(&params, 0, sizeof(Jbig2TextRegionParams));
-
     params.SBHUFF = flags & 0x0001;
     params.SBREFINE = flags & 0x0002;
     params.LOGSBSTRIPS = (flags & 0x000c) >> 2;
@@ -633,8 +637,10 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
 
     if (params.SBHUFF) {        /* Huffman coding */
         /* 7.4.3.1.2 */
-        if (segment->data_length - offset < 2)
-            goto too_short;
+        if (segment->data_length - offset < 2) {
+            code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+            goto cleanup2;
+        }
         huffman_flags = jbig2_get_uint16(segment_data + offset);
         offset += 2;
 
@@ -643,8 +649,10 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
     } else {                    /* arithmetic coding */
 
         /* 7.4.3.1.3 */
-        if (segment->data_length - offset < 4)
-            goto too_short;
+        if (segment->data_length - offset < 4) {
+            code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+            goto cleanup2;
+        }
         if ((params.SBREFINE) && !(params.SBRTEMPLATE)) {
             params.sbrat[0] = segment_data[offset];
             params.sbrat[1] = segment_data[offset + 1];
@@ -655,8 +663,10 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
     }
 
     /* 7.4.3.1.4 */
-    if (segment->data_length - offset < 4)
-        goto too_short;
+    if (segment->data_length - offset < 4) {
+        code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+        goto cleanup2;
+    }
     params.SBNUMINSTANCES = jbig2_get_uint32(segment_data + offset);
     offset += 4;
 
@@ -922,8 +932,10 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
         goto cleanup2;
     }
 
-    if (offset >= segment->data_length)
-        goto too_short;
+    if (offset >= segment->data_length) {
+        code = jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
+        goto cleanup2;
+    }
     ws = jbig2_word_stream_buf_new(ctx, segment_data + offset, segment->data_length - offset);
     if (ws == NULL) {
         code = jbig2_error(ctx, JBIG2_SEVERITY_WARNING, segment->number, "failed to allocate word stream when handling text region image");
@@ -937,7 +949,8 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
     }
 
     if (!params.SBHUFF) {
-        uint32_t SBSYMCODELEN, index;
+        uint8_t SBSYMCODELEN;
+        uint32_t index;
         uint32_t SBNUMSYMS = 0;
 
         for (index = 0; index < n_dicts; index++) {
@@ -954,8 +967,8 @@ jbig2_text_region(Jbig2Ctx *ctx, Jbig2Se
         }
 
         /* Table 31 */
-        for (SBSYMCODELEN = 0; (1U << SBSYMCODELEN) < SBNUMSYMS; SBSYMCODELEN++) {
-        }
+        for (SBSYMCODELEN = 0; ((uint64_t) 1 << SBSYMCODELEN) < (uint64_t) SBNUMSYMS; SBSYMCODELEN++);
+
         params.IAID = jbig2_arith_iaid_ctx_new(ctx, SBSYMCODELEN);
         params.IARI = jbig2_arith_int_ctx_new(ctx);
         params.IARDW = jbig2_arith_int_ctx_new(ctx);
@@ -1027,7 +1040,4 @@ cleanup1:
     jbig2_free(ctx->allocator, dicts);
 
     return code;
-
-too_short:
-    return jbig2_error(ctx, JBIG2_SEVERITY_FATAL, segment->number, "segment too short");
 }
diff -pruN 0.18-1/jbig2_text.h 0.18+20200417-1/jbig2_text.h
--- 0.18-1/jbig2_text.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/jbig2_text.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/memcmp.c 0.18+20200417-1/memcmp.c
--- 0.18-1/memcmp.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/memcmp.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/msvc.mak 0.18+20200417-1/msvc.mak
--- 0.18-1/msvc.mak	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/msvc.mak	2020-04-17 09:11:03.000000000 +0000
@@ -33,7 +33,7 @@ JBIG2_IMAGE_PNG_OBJ=
 EXE=.exe
 OBJ=.obj
 NUL=
-CFLAGS=-nologo -W4 -Zi -DHAVE_STRING_H=1 -D_CRT_SECURE_NO_WARNINGS $(LIBPNG_CFLAGS) 
+CFLAGS=-nologo -W4 -Zi -DHAVE_STRING_H=1 -D_CRT_SECURE_NO_WARNINGS $(LIBPNG_CFLAGS)
 CC=cl
 FE=-Fe
 
@@ -55,7 +55,7 @@ HDRS=getopt.h jbig2.h jbig2_arith.h jbig
 all: jbig2dec$(EXE)
 
 jbig2dec$(EXE): $(OBJS)
-	$(CC) $(CFLAGS) $(FE)jbig2dec$(EXE) $(OBJS) $(LIBPNG_LDFLAGS) 
+	$(CC) $(CFLAGS) $(FE)jbig2dec$(EXE) $(OBJS) $(LIBPNG_LDFLAGS)
 
 getopt$(OBJ): getopt.c getopt.h
 	$(CC) $(CFLAGS) -c getopt.c
diff -pruN 0.18-1/os_types.h 0.18+20200417-1/os_types.h
--- 0.18-1/os_types.h	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/os_types.h	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/pbm2png.c 0.18+20200417-1/pbm2png.c
--- 0.18-1/pbm2png.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/pbm2png.c	2020-04-17 09:11:03.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2001-2019 Artifex Software, Inc.
+/* Copyright (C) 2001-2020 Artifex Software, Inc.
    All Rights Reserved.
 
    This software is provided AS-IS with no warranty, either express or
diff -pruN 0.18-1/snprintf.c 0.18+20200417-1/snprintf.c
--- 0.18-1/snprintf.c	2020-02-11 16:28:00.000000000 +0000
+++ 0.18+20200417-1/snprintf.c	1970-01-01 00:00:00.000000000 +0000
@@ -1,163 +0,0 @@
-/*
- * Revision 12: http://theos.com/~deraadt/snprintf.c
- *
- * Copyright (c) 1997 Theo de Raadt
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef __VMS
-#include <param.h>
-#else
-#include <sys/param.h>
-#endif
-#include <sys/types.h>
-#include <sys/mman.h>
-#include <signal.h>
-#include <stdio.h>
-#if __STDC__
-#include <stdarg.h>
-#include <stdlib.h>
-#else
-#include <varargs.h>
-#endif
-#include <setjmp.h>
-#include <unistd.h>
-#include <string.h>
-
-#ifndef roundup
-#define roundup(x, y) ((((x)+((y)-1))/(y))*(y))
-#endif
-
-#ifdef __sgi
-#define size_t ssize_t
-#endif
-
-static int pgsize;
-static char *curobj;
-static int caught;
-static sigjmp_buf bail;
-
-#define EXTRABYTES	2       /* XXX: why 2? you don't want to know */
-
-static char *
-msetup(str, n)
-char *str;
-size_t n;
-{
-    char *e;
-
-    if (n == 0)
-        return NULL;
-    if (pgsize == 0)
-        pgsize = getpagesize();
-    curobj = (char *)malloc(n + EXTRABYTES + pgsize * 2);
-    if (curobj == NULL)
-        return NULL;
-    e = curobj + n + EXTRABYTES;
-    e = (char *)roundup((unsigned long)e, pgsize);
-    if (mprotect(e, pgsize, PROT_NONE) == -1) {
-        free(curobj);
-        curobj = NULL;
-        return NULL;
-    }
-    e = e - n - EXTRABYTES;
-    *e = '\0';
-    return (e);
-}
-
-static void
-mcatch(int a)
-{
-    siglongjmp(bail, 1);
-}
-
-static void
-mcleanup(str, n, p)
-char *str;
-size_t n;
-char *p;
-{
-    strncpy(str, p, n - 1);
-    str[n - 1] = '\0';
-    if (mprotect((caddr_t)(p + n + EXTRABYTES), pgsize, PROT_READ | PROT_WRITE | PROT_EXEC) == -1)
-        mprotect((caddr_t)(p + n + EXTRABYTES), pgsize, PROT_READ | PROT_WRITE);
-    free(curobj);
-}
-
-int
-#if __STDC__
-vsnprintf(char *str, size_t n, char const *fmt, va_list ap)
-#else
-vsnprintf(str, n, fmt, ap)
-char *str;
-size_t n;
-char *fmt;
-char *ap;
-#endif
-{
-    struct sigaction osa, nsa;
-    char *p;
-    int ret = n + 1;            /* if we bail, indicated we overflowed */
-
-    memset(&nsa, 0, sizeof nsa);
-    nsa.sa_handler = mcatch;
-    sigemptyset(&nsa.sa_mask);
-
-    p = msetup(str, n);
-    if (p == NULL) {
-        *str = '\0';
-        return 0;
-    }
-    if (sigsetjmp(bail, 1) == 0) {
-        if (sigaction(SIGSEGV, &nsa, &osa) == -1) {
-            mcleanup(str, n, p);
-            return (0);
-        }
-        ret = vsprintf(p, fmt, ap);
-    }
-    mcleanup(str, n, p);
-    (void)sigaction(SIGSEGV, &osa, NULL);
-    return (ret);
-}
-
-int
-#if __STDC__
-snprintf(char *str, size_t n, char const *fmt, ...)
-#else
-snprintf(str, n, fmt, va_alist)
-char *str;
-size_t n;
-char *fmt;
-va_dcl
-#endif
-{
-    va_list ap;
-
-#if __STDC__
-    va_start(ap, fmt);
-#else
-    va_start(ap);
-#endif
-
-    return (vsnprintf(str, n, fmt, ap));
-    va_end(ap);
-}
